/* PituKa - Amstrad CPC Emulator
	(c) Copyright 2004-2005 David Skywalker
   BASED ON:
   Caprice32 - Amstrad CPC Emulator
   (c) Copyright 1997-2004 Ulrich Doewich

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


   Oct 11, 2000 - 22:12 preliminary IN/OUT handlers; started with the GA OUT register write routines
   Oct 12, 2000 - 23:31 added GA ROM select to z80_OUT_handler
   Oct 14, 2000 - 13:58 added PPI IN/OUT handlers
   Oct 15, 2000 - 15:33 added CRTC IN/OUT handlers
   Oct 20, 2000 - 23:23 fixed some IN/OUT handler bugs
   Oct 27, 2000 - 17:39 added reset_CPC
   Oct 30, 2000 - 21:05 found the problem with the streched display: scr_bps needs to be in cpc_dwords, not bytes!
   Nov 01, 2000 - 23:43 aargh! found the BASIC 'reset' bug: the pbROMhi variable was pointing to the wrong location!
   Nov 03, 2000 - 18:03 added keyboard_interrupt handler
   Nov 03, 2000 - 19:10 added preliminary PSG register write handlers
   Nov 03, 2000 - 23:37 fixed the PPI port C handler; CPC keyboard works now!
   Dec 12, 2000 - 18:14 changed load_dsk() to work with a C based disk info structure
   Jan 24, 2001 - 22:28 loading from disk images works (again)!
   Apr 06, 2001 - 12:52 fixed the keyboard translation table (Allegro WIP 3.9.34 added 3 more keys to the array)
.....
   GP PORT 0.5e
      by D_Skywalk
      
   12 Jul 2004 - 3:46 Pasando de SDL A GP32.h 0.01
   7 oct 2004 - 3:00 Optimizacion y GUI (0.5e)
*/

//#include <zlib.h>
//#include <png.h>
//#include "SDL.h"
//#include <GP32_MOD.h>

//LIBS
#include <gpgraphic.h>
//#include <gpstdio.h>
#include <gpstdlib.h>
#include <gpfont.h>
#include <stdlib.h>

//RECURSOS
#include "cap32.h"
#include "crtc.h"
#include "tape.h"
#include "z80.h"


//PORT GP32
#include "port/ROM_6128.c"
#include "port/ROM_amsdos.c"
#include "rlyeh/sound/gpsoundbuf.h"

//NUEVO CORE SOUND
//#include "aysound/ay8910.h"

#define VERSION_STRING "v0.9"

#define ERR_INPUT_INIT           1
#define ERR_VIDEO_INIT           2
#define ERR_VIDEO_SET_MODE       3
#define ERR_VIDEO_SURFACE        4
#define ERR_VIDEO_PALETTE        5
#define ERR_VIDEO_COLOUR_DEPTH   6
#define ERR_AUDIO_INIT           7
#define ERR_AUDIO_RATE           8
#define ERR_OUT_OF_MEMORY        9
#define ERR_CPC_ROM_MISSING      10
#define ERR_NOT_A_CPC_ROM        11
#define ERR_ROM_NOT_FOUND        12
#define ERR_FILE_NOT_FOUND       13
#define ERR_FILE_BAD_ZIP         14
#define ERR_FILE_EMPTY_ZIP       15
#define ERR_FILE_UNZIP_FAILED    16
#define ERR_SNA_INVALID          17
#define ERR_SNA_SIZE             18
#define ERR_SNA_CPC_TYPE         19
#define ERR_SNA_WRITE            20
#define ERR_DSK_INVALID          21
#define ERR_DSK_SIDES            22
#define ERR_DSK_SECTORS          23
#define ERR_DSK_WRITE            24
#define MSG_DSK_ALTERED          25
#define ERR_TAP_INVALID          26
#define ERR_TAP_UNSUPPORTED      27
#define ERR_TAP_BAD_VOC          28
#define ERR_PRINTER              29
#define ERR_BAD_MF2_ROM          30
#define ERR_SDUMP                31

#define MSG_SNA_LOAD             32
#define MSG_SNA_SAVE             33
#define MSG_DSK_LOAD             34
#define MSG_DSK_SAVE             35
#define MSG_JOY_ENABLE           36
#define MSG_JOY_DISABLE          37
#define MSG_SPD_NORMAL           38
#define MSG_SPD_FULL             39
#define MSG_TAP_INSERT           40
#define MSG_SDUMP_SAVE           41
#define MSG_PAUSED               42
#define MSG_TAP_PLAY             43
#define MSG_TAP_STOP             44

#define MAX_LINE_LEN 256

#define MIN_SPEED_SETTING 2
#define MAX_SPEED_SETTING 32
#define DEF_SPEED_SETTING 4 //ORIGINAL
//#define DEF_SPEED_SETTING 8

//NUEVO PSG
//#include "ayports.c"
//extern AY8910_CORE AY;



extern cpc_byte bTapeLevel;
extern t_z80regs z80;
//extern bool sonido_ant;

//PituKa
extern bool GPChangeDISK;
extern PituKa_CFG configuracion; 

extern char extension[5];
extern char file_state[13];
extern char rom_name[16];

extern Pituka_SpoolKeys spoolkeys;
extern cpc_byte reiniciado;
extern bool pinta_menu;

extern bool save_state;
extern bool load_state;
extern unsigned char result_state; //1 load ok, //2 save ok


char GPDebug[100]="\0";
#ifdef DEBUG_Z80
unsigned char teclita;
#endif

/*
typedef struct{
  int x, y;
  int px, py;
} GP_cursor;

//SDL_AudioSpec *audio_spec = NULL;

SDL_Surface *video_surface = NULL;
SDL_Surface *back_surface = NULL;
SDL_Rect video_rect, back_rect;
*/

 GPSOUNDBUF sonido;
extern bool sonido_ant;

extern 	void * buffer;

GP_Rect video_rect, back_rect;

extern GP_cursor puntero;

extern int GPframeskip;
extern int GPframe;
extern char spool_cad[20];
extern bool spool;
extern bool spool_act;

//CHATBOARD
extern int chatboard;
//int chatboardSymb=0, chatboardShift=0, chatboardExt=0;


//GPDRAWSURFACE * video_surface;
//GPDRAWSURFACE * back_surface;

//unsigned char * fondo;

//int nflip;			        /* Video buffer index */
//GPDRAWSURFACE gpDraw;	/* Video Buffers */
extern GP_HPALETTE paleta;         /* Paleta de Color 8bits */

extern const unsigned char logoPITUKAcont[76800];
extern const unsigned char logoPITUKAchat[76800];

extern const unsigned char tecladoPITUKA[20480];
extern GP_PALETTEENTRY logo_Pal[65];
extern GP_PALETTEENTRY teclado_Pal[16];

//unsigned char buffer_grafico[CPC_SCR_WIDTH*(CPC_SCR_HEIGHT*CPC_SCR_MULTI)];

unsigned char *Picture=(unsigned char *)0x0c7b4000;
unsigned char *PictureAlt=(unsigned char *)0x0c7b4000+320*240;
int gpDrawSurfaceIndex=0;

cpc_dword button_state;

//unsigned char GPframe=0;

cpc_dword dwTicks, dwTicksOffset, dwTicksTarget, dwTicksTargetFPS;
//int dwFPS, dwFrameCount;
cpc_dword dwXScale, dwYScale;
cpc_dword dwSndMinSafeDist, dwSndMaxSafeDist;

cpc_dword dwBreakPoint, dwTrace, dwMF2ExitAddr;
cpc_dword dwMF2Flags = 0;

int GA_N=0;

cpc_byte *pbGPBuffer = NULL;
unsigned char *pbSndBuffer = NULL;
unsigned char *pbSndBufferEnd = NULL;
unsigned char *pbSndStream = NULL;
cpc_byte *membank_read[4], *membank_write[4], *memmap_ROM[256];
cpc_byte *pbRAM = NULL;
cpc_byte *pbROMlo = NULL;
cpc_byte *pbROMhi = NULL;
cpc_byte *pbExpansionROM = NULL;
cpc_byte *pbMF2ROMbackup = NULL;
cpc_byte *pbMF2ROM = NULL;
cpc_byte *pbTapeImage = NULL;
cpc_byte *pbTapeImageEnd = NULL;
cpc_byte mode0_table[512], mode1_table[1024];
cpc_byte keyboard_matrix[16];

static cpc_byte *membank_config[8][4];
		//HACIENDOLA GENERAL :?
		 cpc_byte *pbPtr;
		 
 
//FILE *pfileObject;
//FILE *pfoPrinter;

F_HANDLE pfileObject;
F_HANDLE pfoPrinter;


#ifdef DEBUG
F_HANDLE pfoDebug;
#endif


typedef void (*MH)(cpc_dword);
typedef void (*BH)(void);

MH mode_handler[4] = {
   draw8bpp_mode0_half,
   draw8bpp_mode1_half,
   draw8bpp_mode2_half,
   draw8bpp_mode0_half,
};
BH border_handler = draw8bpp_border_half;

//HACERLO TB CON LA SUMA xD
static const cpc_byte tabla_resta[240]=
{
239,238,237,236,235,234,233,232,231,230,229,228,227,226,225,224,223,222,221,220,
219,218,217,216,215,214,213,212,211,210,209,208,207,206,205,204,203,202,201,200,
199,198,197,196,195,194,193,192,191,190,189,188,187,186,185,184,183,182,181,180,
179,178,177,176,175,174,173,172,171,170,169,168,167,166,165,164,163,162,161,160,
159,158,157,156,155,154,153,152,151,150,149,148,147,146,145,144,143,142,141,140,
139,138,137,136,135,134,133,132,131,130,129,128,127,126,125,124,123,122,121,120,
119,118,117,116,115,114,113,112,111,110,109,108,107,106,105,104,103,102,101,100,
99,98,97,96,95,94,93,92,91,90,89,88,87,86,85,84,83,82,81,80,
79,78,77,76,75,74,73,72,71,70,69,68,67,66,65,64,63,62,61,60,
59,58,57,56,55,54,53,52,51,50,49,48,47,46,45,44,43,42,41,40,
39,38,37,36,35,34,33,32,31,30,29,28,27,26,25,24,23,22,21,20,
19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1,0
};


#define MAX_FREQ_ENTRIES 5
cpc_dword freq_table[MAX_FREQ_ENTRIES] = {
   11025,
   22050,
   44100,
   48000,
   96000
};


static double colours_rgb[32][3] = {
   { 0.5, 0.5, 0.5 }, { 0.5, 0.5, 0.5 },{ 0.0, 1.0, 0.5 }, { 1.0, 1.0, 0.5 },
   { 0.0, 0.0, 0.5 }, { 1.0, 0.0, 0.5 },{ 0.0, 0.5, 0.5 }, { 1.0, 0.5, 0.5 },
   { 1.0, 0.0, 0.5 }, { 1.0, 1.0, 0.5 },{ 1.0, 1.0, 0.0 }, { 1.0, 1.0, 1.0 },
   { 1.0, 0.0, 0.0 }, { 1.0, 0.0, 1.0 },{ 1.0, 0.5, 0.0 }, { 1.0, 0.5, 1.0 },
   { 0.0, 0.0, 0.5 }, { 0.0, 1.0, 0.5 },{ 0.0, 1.0, 0.0 }, { 0.0, 1.0, 1.0 },
   { 0.0, 0.0, 0.0 }, { 0.0, 0.0, 1.0 },{ 0.0, 0.5, 0.0 }, { 0.0, 0.5, 1.0 },
   { 0.5, 0.0, 0.5 }, { 0.5, 1.0, 0.5 },{ 0.5, 1.0, 0.0 }, { 0.5, 1.0, 1.0 },
   { 0.5, 0.0, 0.0 }, { 0.5, 0.0, 1.0 },{ 0.5, 0.5, 0.0 }, { 0.5, 0.5, 1.0 }
};

static double colours_green[32] = {
   0.5647, 0.5647, 0.7529, 0.9412,
   0.1882, 0.3765, 0.4706, 0.6588,
   0.3765, 0.9412, 0.9098, 0.9725,
   0.3451, 0.4078, 0.6275, 0.6902,
   0.1882, 0.7529, 0.7216, 0.7843,
   0.1569, 0.2196, 0.4392, 0.5020,
   0.2824, 0.8471, 0.8157, 0.8784,
   0.2510, 0.3137, 0.5333, 0.5961
};

cpc_dword colour_table[32];

static cpc_byte CRTC_values[2][14] = {
   {0x3f, 0x28, 0x2e, 0x8e, 0x1f, 0x06, 0x19, 0x1b, 0x00, 0x07, 0x00, 0x00, 0x30, 0x00},
   {0x3f, 0x28, 0x2e, 0x8e, 0x26, 0x00, 0x19, 0x1e, 0x00, 0x07, 0x00, 0x00, 0x30, 0x00}
};

/*static*/
 cpc_byte bit_values[8] = {
   0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80
};


/*static*/
 cpc_byte keyboard_translation[320] = {
//
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
// BKSPC   TAB                             ENTER
   0x97,   0x84,   0xff,   0xff,   0xff,   0x22,   0xff,   0xff,
//
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
//                         ESC
   0xff,   0xff,   0xff,   0x82,   0xff,   0xff,   0xff,   0xff,
// SPACE           3                               1
   0x57,   0xff,   0x71,   0xff,   0xff,   0xff,   /*0x80*/ 0xff,   0xff,
// 5                               ,       -       .       /
   0x61,   0xff,   0xff,   0xff,   0x47,   0x31,   0x37,   0x36,
// 0       1       2       3       4       5       6       7
   0x40,   0x80,   0x81,   0x71,   0x70,   0x61,   0x60,   0x51,
// 8       9               ;               =
   0x50,   0x41,   0xff,   0x35,   0xff,   0x30,   0xff,   0xff,
//
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
//
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
//
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
//                         [       \       ]               8
   0xff,   0xff,   0xff,   0x32,   0x23,   0x21,   0xff,   0x50,
//         A       B       C       D       E       F       G
   0xff,   0x85,   0x66,   0x76,   0x75,   0x72,   0x65,   0x64,
// H       I       J       K       L       M       N       O
   0x54,   0x43,   0x55,   0x45,   0x44,   0x46,   0x56,   0x42,
// P       Q       R       S       T       U       V       W
   0x33,   0x83,   0x62,   0x74,   0x63,   0x52,   0x67,   0x73,
// X       Y       Z                                       DEL
   0x77,   0x53,   0x87,   0xff,   0xff,   0xff,   0xff,   0xff,
//
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
//
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
//
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
//
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
//
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
//
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
// BKSPC   TAB                             ENTER
   0x97,   0x84,   0xff,   0xff,   0xff,   0x22,   0xff,   0xff,
//
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
//
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
//
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
//
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
//
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
// 0                                                       9
   0x40,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0x41,
// 7       2
   0x51,   0x81,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
//
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
//
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
// NP0     NP1     NP2     NP3     NP4     NP5     NP6     NP7
   0x17,   0x15,   0x16,   0x05,   0x24,   0x14,   0x04,   0x12,
// NP8     NP9     NP.     NP/     NP*     NP-     NP+     NPENT
   0x13,   0x03,   0x07,   0xff,   0xff,   0xff,   0xff,   0x06,
//         CURUP   CURDN   CURRT   CURLF   INS     HOME    END
   0xff,   0x00,   0x02,   0x01,   0x10,   0x20,   0xff,   0xff,
// PGUP    PGDWN   F1      F2      F3      F4      F5      F6
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
// F7      F8      F9      F10     F11     F12
   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff,
//                                 NUMLK   CPSLK   SCRLK   RSHFT
   0xff,   0xff,   0xff,   0xff,   0xff,   0x86,   0xff,   0x25,
// LSHFT   RCTRL   LCTRL           LALT
   0x25,   0xff,   0x27,   0xff,   0x11,   0xff,   0xff,   0xff,
//         RALT                    SYSRQ
   0xff,   0x26,   0xff,   0xff,   0xff,   0xff,   0xff,   0xff
};

/*
#define CAP32_FULLSCRN  SDLK_BACKQUOTE
#define CAP32_LOADSNAP  SDLK_F2
#define CAP32_SAVESNAP  SDLK_F4
#define CAP32_RESET     SDLK_F5
#define CAP32_LOADDRVA  SDLK_F6
#define CAP32_LOADDRVB  SDLK_F7
#define CAP32_LOADTAPE  SDLK_F3
#define CAP32_OPTIONS   SDLK_F8
#define CAP32_EXIT      SDLK_F10
#define CAP32_MF2STOP   SDLK_F11
#define CAP32_SPEED     SDLK_F12
#define CAP32_PAUSE     SDLK_BREAK
#define CAP32_SCRNSHOT  SDLK_PRINT
*/

/* Button definitions */

#define CAP32_FULLSCRN  GPC_VK_NONE
#define CAP32_LOADSNAP  GPC_VK_NONE
#define CAP32_SAVESNAP  GPC_VK_NONE
#define CAP32_LOADDRVB  GPC_VK_NONE
#define CAP32_LOADTAPE  GPC_VK_NONE
#define CAP32_MF2STOP   GPC_VK_NONE
#define CAP32_SPEED     GPC_VK_FL
#define CAP32_PAUSE     GPC_VK_NONE
#define CAP32_SCRNSHOT  GPC_VK_NONE

#define CAP32_RESET     GPC_VK_START
#define CAP32_LOADDRVA  GPC_VK_NONE
#define CAP32_OPTIONS   GPC_VK_SELECT
#define CAP32_EXIT      GPC_VK_FR


#define MAX_KBD_LAYOUTS 2
//#include "rom_mods.c"

char chAppPath[_MAX_PATH + 1];
char chROMSelected[_MAX_PATH + 1];
char chROMFile[3][14] = {
   "cpc464.rom",
   "cpc664.rom",
   "cpc6128.rom"
};

t_CPC CPC;
t_CRTC CRTC;
t_FDC FDC;
t_GateArray GateArray;
t_PPI PPI;
t_PSG PSG;
t_VDU VDU;

t_drive driveA;
t_drive driveB;

extern int Left_Chan;


#define MAX_DISK_FORMAT 8
#define DEFAULT_DISK_FORMAT 0
#define FIRST_CUSTOM_DISK_FORMAT 2
t_disk_format disk_format[MAX_DISK_FORMAT] = {
   { "178K Data Format", 40, 1, 9, 2, 0x52, 0xe5, {{ 0xc1, 0xc6, 0xc2, 0xc7, 0xc3, 0xc8, 0xc4, 0xc9, 0xc5 }} },
   { "169K Vendor Format", 40, 1, 9, 2, 0x52, 0xe5, {{ 0x41, 0x46, 0x42, 0x47, 0x43, 0x48, 0x44, 0x49, 0x45 }} }
};


//FIN STRINGS
         
//ANTIGUO SONIDO
#define psg_write \
{ \
   cpc_byte control = PSG.control & 0xc0; /* isolate PSG control bits */ \
   if (control == 0xc0) { /* latch address? */ \
      PSG.reg_select = psg_data; /* select new PSG register */ \
   } else if (control == 0x80) { /* write? */ \
      if (PSG.reg_select < 16) { /* valid register? */ \
	  SetAYRegister(PSG.reg_select, psg_data);  \
		/* sound_ay_write(PSG.reg_select, psg_data, CPC.cycle_count);*/ \
      } \
   } \
}


void ga_init_banking (void)
{
   cpc_byte *romb0, *romb1, *romb2, *romb3, *romb4, *romb5, *romb6, *romb7;
   cpc_byte *pbRAMbank;

   romb0 = pbRAM;
   romb1 = pbRAM + 1*16384;
   romb2 = pbRAM + 2*16384;
   romb3 = pbRAM + 3*16384;

   pbRAMbank = pbRAM + ((GateArray.RAM_bank + 1) * 65536);
   romb4 = pbRAMbank;
   romb5 = pbRAMbank + 1*16384;
   romb6 = pbRAMbank + 2*16384;
   romb7 = pbRAMbank + 3*16384;

   membank_config[0][0] = romb0;
   membank_config[0][1] = romb1;
   membank_config[0][2] = romb2;
   membank_config[0][3] = romb3;

   membank_config[1][0] = romb0;
   membank_config[1][1] = romb1;
   membank_config[1][2] = romb2;
   membank_config[1][3] = romb7;

   membank_config[2][0] = romb4;
   membank_config[2][1] = romb5;
   membank_config[2][2] = romb6;
   membank_config[2][3] = romb7;

   membank_config[3][0] = romb0;
   membank_config[3][1] = romb3;
   membank_config[3][2] = romb2;
   membank_config[3][3] = romb7;

   membank_config[4][0] = romb0;
   membank_config[4][1] = romb4;
   membank_config[4][2] = romb2;
   membank_config[4][3] = romb3;

   membank_config[5][0] = romb0;
   membank_config[5][1] = romb5;
   membank_config[5][2] = romb2;
   membank_config[5][3] = romb3;

   membank_config[6][0] = romb0;
   membank_config[6][1] = romb6;
   membank_config[6][2] = romb2;
   membank_config[6][3] = romb3;

   membank_config[7][0] = romb0;
   membank_config[7][1] = romb7;
   membank_config[7][2] = romb2;
   membank_config[7][3] = romb3;
}



void ga_memory_manager (void)
{
    int n=0;
    
   cpc_dword mem_bank;
   if (CPC.ram_size == 64) { // 64KB of RAM?
      mem_bank = 0; // no expansion memory
      GateArray.RAM_config = 0; // the only valid configuration is 0
   } else {
      mem_bank = (GateArray.RAM_config >> 3) & 7; // extract expansion memory bank
      if (((mem_bank+2)*64) > CPC.ram_size) { // selection is beyond available memory?
         mem_bank = 0; // force default mapping
      }
   }
   if (mem_bank != GateArray.RAM_bank) { // requested bank is different from the active one?
      GateArray.RAM_bank = mem_bank;
      ga_init_banking();
   }
   for (n = 0; n < 4; n++) { // remap active memory banks
//	  fprintf(pfoDebug, "\n GA: %x : %x - (0x%04x) ",n,GateArray.RAM_config, membank_config[GateArray.RAM_config & 7][n]);
      membank_read[n] = membank_config[GateArray.RAM_config & 7][n];
      membank_write[n] = membank_config[GateArray.RAM_config & 7][n];
//	  fprintf(pfoDebug, "\n\t%x - %x (0x%02x - x%02x)", n, membank_config[GateArray.RAM_config & 7][n], membank_read[n], * membank_read[n]);
   }

   if (!(GateArray.ROM_config & 0x04)) { // lower ROM is enabled?
      if (dwMF2Flags & MF2_ACTIVE) { // is the Multiface 2 paged in?
         membank_read[0] = pbMF2ROM;
         membank_write[0] = pbMF2ROM;
      } else {
         membank_read[0] = pbROMlo; // 'page in' lower ROM
      }
   }
   if (!(GateArray.ROM_config & 0x08)) { // upper/expansion ROM is enabled?
      membank_read[3] = pbExpansionROM; // 'page in' upper/expansion ROM
   }
   GA_N++;

}



cpc_byte z80_IN_handler (reg_pair port)
{
   cpc_byte ret_val;
   cpc_byte direction;

   ret_val = 0xff; // default return value
// CRTC -----------------------------------------------------------------------
   if (!(port.b.h & 0x40)) { // CRTC chip select?
      if ((port.b.h & 3) == 3) { // read CRTC register?
         if ((CRTC.reg_select > 11) && (CRTC.reg_select < 18)) { // valid range?
            ret_val = CRTC.registers[CRTC.reg_select];
         }
         else {
            ret_val = 0; // write only registers return 0
         }
      }
   }
// PPI ------------------------------------------------------------------------
   else if (!(port.b.h & 0x08)) { // PPI chip select?
      cpc_byte ppi_port = port.b.h & 3;
      switch (ppi_port) {
         case 0: // read from port A?
            if (PPI.control & 0x10) { // port A set to input?
               if ((PSG.control & 0xc0) == 0x40) { // PSG control set to read?
                  if (PSG.reg_select < 16) { // within valid range?
                     if (PSG.reg_select == 14) {					 // PSG port A?
                        if (!(PSG.RegisterAY.Index[7] & 0x40)) { // port A in input mode?
                           ret_val = keyboard_matrix[CPC.keyboard_line & 0x0f]; // read keyboard matrix node status
                        } else {
                           ret_val = PSG.RegisterAY.Index[14] & (keyboard_matrix[CPC.keyboard_line & 0x0f]); // return last value w/ logic AND of input
                        }
                     } else if (PSG.reg_select == 15) { // PSG port B?
                        if ((PSG.RegisterAY.Index[7] & 0x80)) { // port B in output mode?
                           ret_val = PSG.RegisterAY.Index[15]; // return stored value
                        }
                     } else {
                        ret_val = PSG.RegisterAY.Index[PSG.reg_select]; // read PSG register
                     }
                  }
               }
            } else {
               ret_val = PPI.portA; // return last programmed value
            }
            break;

         case 1: // read from port B?
            if (PPI.control & 2) { // port B set to input?
               ret_val = bTapeLevel | // tape level when reading
                         (CPC.printer ? 0 : 0x40) | // ready line of connected printer
                         (CPC.jumpers & 0x7f) | // manufacturer + 50Hz
                         (CRTC.flags & VS_flag); // VSYNC status
            } else {
               ret_val = PPI.portB; // return last programmed value
            }
            break;

         case 2: // read from port C?
            direction = PPI.control & 9; // isolate port C directions
            ret_val = PPI.portC; // default to last programmed value
            if (direction) { // either half set to input?
               if (direction & 8) { // upper half set to input?
                  ret_val &= 0x0f; // blank out upper half
                  cpc_byte val = PPI.portC & 0xc0; // isolate PSG control bits
                  if (val == 0xc0) { // PSG specify register?
                     val = 0x80; // change to PSG write register
                  }
                  ret_val |= val | 0x20; // casette write data is always set
  /*                if (CPC.tape_motor) {
                     ret_val |= 0x10; // set the bit if the tape motor is running
                  }*/
               }
               if (!(direction & 1)) { // lower half set to output?
                  ret_val |= 0x0f; // invalid - set all bits
               }
            }
            break;
      }
   }
// ----------------------------------------------------------------------------
   else if (!(port.b.h & 0x04)) { // external peripheral?
      if ((port.b.h == 0xfb) && (!(port.b.l & 0x80))) { // FDC?
         if (!(port.b.l & 0x01)) { // FDC status register?
            ret_val = fdc_read_status();
         } else { // FDC data register
            ret_val = fdc_read_data();
         }
      }
   }
   return ret_val;
}



void z80_OUT_handler (reg_pair port, cpc_byte val)
{
// Gate Array -----------------------------------------------------------------
   if ((port.b.h & 0xc0) == 0x40) { // GA chip select?
      switch (val >> 6) {
         case 0: // select pen
            #ifdef DEBUG_GA
            if (dwDebugFlag) {
               GP_fprintf(pfoDebug, "pen 0x%02x\r\n", val);
            }
            #endif
            GateArray.pen = val & 0x10 ? 0x10 : val & 0x0f; // if bit 5 is set, pen indexes the border colour
            if (CPC.mf2) { // MF2 enabled?
               *(pbMF2ROM + 0x03fcf) = val;
            }
            break;
         case 1: // set colour
            #ifdef DEBUG_GA
            if (dwDebugFlag) {
               GP_fprintf(pfoDebug, "clr 0x%02x\r\n", val);
            }
            #endif
            {
               cpc_byte colour = val & 0x1f; // isolate colour value
               GateArray.ink_values[GateArray.pen] = colour;
               GateArray.palette[GateArray.pen] = colour_table[colour];
            }
 /*           if (CPC.mf2) { // MF2 enabled?
               int iPen = *(pbMF2ROM + 0x03fcf);
               *(pbMF2ROM + (0x03f90 | ((iPen & 0x10) << 2) | (iPen & 0x0f))) = val;
            }*/
            break;
         case 2: // set mode
            #ifdef DEBUG_GA
            if (dwDebugFlag) {
               GP_fprintf(pfoDebug, "rom 0x%02x\r\n", val);
            }
            #endif
            GateArray.ROM_config = val;
            GateArray.requested_scr_mode = (void(*)(cpc_dword))mode_handler[val & 0x03]; // request a new CPC screen mode
            ga_memory_manager();
            if (val & 0x10) { // delay Z80 interrupt?
               z80.int_pending = 0; // clear pending interrupts
               GateArray.sl_count = 0; // reset GA scanline counter
            }
   /*         if (CPC.mf2) { // MF2 enabled?
               *(pbMF2ROM + 0x03fef) = val;
            }*/
            break;
         case 3: // set memory configuration
            #ifdef DEBUG_GA
            if (dwDebugFlag) {
               GP_fprintf(pfoDebug, "mem 0x%02x\r\n", val);
            }
            #endif
            GateArray.RAM_config = val;
            ga_memory_manager();
 /*           if (CPC.mf2) { // MF2 enabled?
               *(pbMF2ROM + 0x03fff) = val;
            }*/
            break;
      }
   }
// CRTC -----------------------------------------------------------------------
   if (!(port.b.h & 0x40)) { // CRTC chip select?
      cpc_byte crtc_port = port.b.h & 3;
      if (crtc_port == 0) { // CRTC register select?
         CRTC.reg_select = val;
         if (CPC.mf2) { // MF2 enabled?
            *(pbMF2ROM + 0x03cff) = val;
         }
      }
      else if (crtc_port == 1) { // CRTC write data?
         if (CRTC.reg_select < 16) { // only registers 0 - 15 can be written to
            CRTC.registers[CRTC.reg_select] = val;
            switch (CRTC.reg_select) {
               case 3: // sync width
                  CRTC.hsw = val & 0x0f; // isolate horizontal sync width
                  VDU.hsw = CRTC.hsw - 2; // GA delays HSYNC by 2 chars
                  if (VDU.hsw < 0) { // negative value?
                     VDU.hsw = 0; // no VDU HSYNC
                  }
                  else if (VDU.hsw > 4) { // HSYNC longer than 4 chars?
                     VDU.hsw = 4; // maxium of 4
                  }
                  CRTC.vsw = val >> 4; // isolate vertical sync width
                  if (!CRTC.vsw) {
                     CRTC.vsw = 16; // 0 = width of 16
                  }
                  break;
               case 5: // vertical total adjust
                  CRTC.vt_adjust = val & 0x1f;
                  break;
/*               case 8: // interlace and skew
                  CRTC.skew = (val >> 4) & 3; // isolate display timing skew
                  if (CRTC.skew == 3) { // no output?
                     CRTC.skew = 0xff;
                  }
                  break;*/
               case 9: // maximum raster count
                  CRTC.max_raster = val << 3; // modify value for easier handling
                  break;
               case 12: // start address high byte
               case 13: // start address low byte
                  {
                     cpc_dword val1 = CRTC.registers[12] & 0x3f;
                     cpc_dword val2 = val1 & 0x0f; // isolate screen size
                     val1 = (val1 << 1) & 0x60; // isolate CPC RAM bank
                     val2 |= val1; // combine
                     CRTC.requested_addr = (CRTC.registers[13] + (val2 << 8)) << 1;
                  }
                  break;
            }
         }
 /*        if (CPC.mf2) { // MF2 enabled?
            *(pbMF2ROM + (0x03db0 | (*(pbMF2ROM + 0x03cff) & 0x0f))) = val;
         }*/
      }
   }
// ROM select -----------------------------------------------------------------
   if (!(port.b.h & 0x20)) { // ROM select?
      GateArray.upper_ROM = val;
      pbExpansionROM = memmap_ROM[val];
      if (pbExpansionROM == NULL) { // selected expansion ROM not present?
         pbExpansionROM = pbROMhi; // revert to BASIC ROM
      }
      if (!(GateArray.ROM_config & 0x08)) { // upper/expansion ROM is enabled?
         membank_read[3] = pbExpansionROM; // 'page in' upper/expansion ROM
      }
 /*     if (CPC.mf2) { // MF2 enabled?
         *(pbMF2ROM + 0x03aac) = val;
      }*/
   }
// printer port ---------------------------------------------------------------
 /*  if (!(port.b.h & 0x10)) { // printer port?
      CPC.printer_port = val ^ 0x80; // invert bit 7
      if (pfoPrinter) {
         if (!(CPC.printer_port & 0x80)) { // only grab data bytes; ignore the strobe signal
//            fputc(CPC.printer_port, pfoPrinter); // capture printer output to file
         }
      }
   }*/
   /*
 //NEW CORE SOUND  ------------------------------------------
  if (!((port.w) & (0xFFFF^0xBFFD)))
   { port_0xbffd(val); return; }

  if (!(port.w & (0xFFFF^0xFFFD)))
   { port_0xfffd(val); return; }


  //fuller audio box emulation
  if (!(port.w & (0xFF^0x3F)))
   { port_0xfffd(val); return; }

  if (!(port.w & (0xFF^0x5F)))
   { port_0xbffd(val); return; }
*/

// PPI ------------------------------------------------------------------------
   if (!(port.b.h & 0x08)) { // PPI chip select?
      switch (port.b.h & 3) {
         case 0: // write to port A?
            PPI.portA = val;
		    #ifdef PSG_org
		    if (!(PPI.control & 0x10)) { // port A set to output?
               cpc_byte psg_data = val;
               psg_write
            }
			#endif
            break;
         case 1: // write to port B?
            PPI.portB = val;
            break;
         case 2: // write to port C?
            PPI.portC = val;
            if (!(PPI.control & 1)) { // output lower half?
               CPC.keyboard_line = val;
            }
			#ifdef PSG_org
            if (!(PPI.control & 8)) { // output upper half?
               CPC.tape_motor = val & 0x10; // update tape motor control
               PSG.control = val; // change PSG control
               cpc_byte psg_data = PPI.portA;
               psg_write
            }
			#endif
            break;
         case 3: // modify PPI control
            if (val & 0x80) { // change PPI configuration
               PPI.control = val; // update control byte
               PPI.portA = 0; // clear data for all ports
               PPI.portB = 0;
               PPI.portC = 0;
            } else { // bit manipulation of port C data
               if (val & 1) { // set bit?
                  cpc_byte bit = (val >> 1) & 7; // isolate bit to set
                  PPI.portC |= bit_values[bit]; // set requested bit
                  if (!(PPI.control & 1)) { // output lower half?
                     CPC.keyboard_line = PPI.portC;
                  }
				  #ifdef PSG_org
                  if (!(PPI.control & 8)) { // output upper half?
                     CPC.tape_motor = PPI.portC & 0x10;
                     PSG.control = PPI.portC; // change PSG control
                     cpc_byte psg_data = PPI.portA;
                     psg_write
                  }
				  #endif
               } else {
                  cpc_byte bit = (val >> 1) & 7; // isolate bit to reset
                  PPI.portC &= ~(bit_values[bit]); // reset requested bit
                  if (!(PPI.control & 1)) { // output lower half?
                     CPC.keyboard_line = PPI.portC;
                  }
				  #ifdef PSG_org
                  if (!(PPI.control & 8)) { // output upper half?
                     CPC.tape_motor = PPI.portC & 0x10;
                     PSG.control = PPI.portC; // change PSG control
                     cpc_byte psg_data = PPI.portA;
                     psg_write
                  }
				  #endif
               }
            }
   /*         if (CPC.mf2) { // MF2 enabled?
               *(pbMF2ROM + 0x037ff) = val;
            }*/
            break;
      }
   }
// ----------------------------------------------------------------------------
   if ((port.b.h == 0xfa) && (!(port.b.l & 0x80))) { // floppy motor control?
      FDC.motor = val & 0x01;
      #ifdef DEBUG_FDC
      if(FDC.motor)//fputs(FDC.motor ? "\r\n--- motor on" : "\r\n--- motor off", pfoDebug);
	  GP_fprintf(pfoDebug,"\r\n--- motor on");
	  else
	  GP_fprintf(pfoDebug,"\r\n--- motor off");	  
      #endif
      FDC.flags |= STATUSDRVA_flag | STATUSDRVB_flag;
   }
   else if ((port.b.h == 0xfb) && (!(port.b.l & 0x80))) { // FDC data register?
      fdc_write_data(val);
   }/*
   else if ((CPC.mf2) && (port.b.h == 0xfe)) { // Multiface 2?
      if ((port.b.l == 0xe8) && (!(dwMF2Flags & MF2_INVISIBLE))) { // page in MF2 ROM?
         dwMF2Flags |= MF2_ACTIVE;
         ga_memory_manager();
      }
      else if (port.b.l == 0xea) { // page out MF2 ROM?
         dwMF2Flags &= ~MF2_ACTIVE;
         ga_memory_manager();
      }
   }*/
 //  fprintf(pfoDebug, "\n\tFUERA F[0]: %x (%02x) F[3]: %x (%02x)", membank_read[0], *membank_read[0], membank_read[3], *membank_read[3]);
}


/*
int file_size (int file_num)
{*/
/*
FORMA 2

GPFILEATTR atributo;
GpFileAttr ("fichero", atributo);

*/

//    ulong size;
/*   struct stat s;

   fstat(file_num, &s);
   return s.st_size;
*/

//GpFileGetSize(???FILE_NUM?, size);
/*return 0;

}
*/



int snapshot_load (char *pchFileName)
{
   //int n;
   dword dwSnapSize, dwModel;
   //char chPath[_MAX_PATH + 1];

   byte val;
   reg_pair port;
   t_SNA_header sh;
   ulong leido=0,n;

   	char path[50];
	if(gm_lstrlen(pchFileName)<=12)
		gm_sprintf(path,"gp:\\gpmm\\amstrad\\snaps\\%s", (char*)pchFileName);
	else
		gm_sprintf(path,"%s", (char*)pchFileName);
   
   gm_memset(&sh, 0, sizeof(sh));
//   if ((pfileObject = fopen(pchFileName, "rb")) != NULL) {
	if (GpFileOpen (path, OPEN_R, &pfileObject)==SM_OK) {

      //fread(&sh, sizeof(sh), 1, pfileObject); // read snapshot header
	  GpFileRead ((F_HANDLE)pfileObject, &sh, sizeof(sh), (ulong*)&leido);

      if (gm_memcmp(sh.id, "MV - SNA", 8) != 0) { // valid SNApshot image?
         GpFileClose((F_HANDLE)pfileObject);
         return ERR_SNA_INVALID;
      }
      dwSnapSize = sh.ram_size[0] + (sh.ram_size[1] * 256); // memory dump size
      dwSnapSize &= ~0x3f; // limit to multiples of 64
      if (!dwSnapSize) {
         GpFileClose((F_HANDLE)pfileObject);
         return ERR_SNA_SIZE;
      }
      if (dwSnapSize > CPC.ram_size) { // memory dump size differs from current RAM size?
         byte *pbTemp;

         //pbTemp = new byte [dwSnapSize*1024];
		 pbTemp = (cpc_byte*) gm_zi_malloc(dwSnapSize*1024); 

         if (pbTemp) {
            //delete [] pbRAM;
			gm_free(pbRAM);
            CPC.ram_size = dwSnapSize;
            pbRAM = pbTemp;
         } else {
            GpFileClose((F_HANDLE)pfileObject);
            return ERR_OUT_OF_MEMORY;
         }
      }
      emulator_reset(false);
      //n = fread(pbRAM, dwSnapSize*1024, 1, pfileObject); // read memory dump into CPC RAM
	  GpFileRead ((F_HANDLE)pfileObject, pbRAM, dwSnapSize*1024, (ulong*)&n);
      GpFileClose((F_HANDLE)pfileObject);
      if (!n) {
         emulator_reset(false);
         return ERR_SNA_INVALID;
      }

// Z80
      _A = sh.AF[1];
      _F = sh.AF[0];
      _B = sh.BC[1];
      _C = sh.BC[0];
      _D = sh.DE[1];
      _E = sh.DE[0];
      _H = sh.HL[1];
      _L = sh.HL[0];
      _R = sh.R & 0x7f;
      _Rb7 = sh.R & 0x80; // bit 7 of R
      _I = sh.I;
      if (sh.IFF0)
         _IFF1 = Pflag;
      if (sh.IFF1)
         _IFF2 = Pflag;
      _IXh = sh.IX[1];
      _IXl = sh.IX[0];
      _IYh = sh.IY[1];
      _IYl = sh.IY[0];
      z80.SP.b.h = sh.SP[1];
      z80.SP.b.l = sh.SP[0];
      z80.PC.b.h = sh.PC[1];
      z80.PC.b.l = sh.PC[0];
      _IM = sh.IM; // interrupt mode
      z80.AFx.b.h = sh.AFx[1];
      z80.AFx.b.l = sh.AFx[0];
      z80.BCx.b.h = sh.BCx[1];
      z80.BCx.b.l = sh.BCx[0];
      z80.DEx.b.h = sh.DEx[1];
      z80.DEx.b.l = sh.DEx[0];
      z80.HLx.b.h = sh.HLx[1];
      z80.HLx.b.l = sh.HLx[0];
// Gate Array
      port.b.h = 0x7f;
      for (n = 0; n < 17; n++) { // loop for all colours + border
         GateArray.pen = n;
         val = sh.ga_ink_values[n]; // GA palette entry
         z80_OUT_handler(port, val | (1<<6));
      }
      val = sh.ga_pen; // GA pen
      z80_OUT_handler(port, (val & 0x3f));
      val = sh.ga_ROM_config; // GA ROM configuration
      z80_OUT_handler(port, (val & 0x3f) | (2<<6));
      val = sh.ga_RAM_config; // GA RAM configuration
      z80_OUT_handler(port, (val & 0x3f) | (3<<6));
// CRTC
      port.b.h = 0xbd;
      for (n = 0; n < 18; n++) { // loop for all CRTC registers
         val = sh.crtc_registers[n];
         CRTC.reg_select = n;
         z80_OUT_handler(port, val);
      }
      port.b.h = 0xbc;
      val = sh.crtc_reg_select; // CRTC register select
      z80_OUT_handler(port, val);
// ROM select
      port.b.h = 0xdf;
      val = sh.upper_ROM; // upper ROM number
      z80_OUT_handler(port, val);
// PPI
      port.b.h = 0xf4; // port A
      z80_OUT_handler(port, sh.ppi_A);
      port.b.h = 0xf5; // port B
      z80_OUT_handler(port, sh.ppi_B);
      port.b.h = 0xf6; // port C
      z80_OUT_handler(port, sh.ppi_C);
      port.b.h = 0xf7; // control
      z80_OUT_handler(port, sh.ppi_control);
// PSG
      PSG.control = PPI.portC;
      PSG.reg_select = sh.psg_reg_select;
      for (n = 0; n < 16; n++) { // loop for all PSG registers
         SetAYRegister(n, sh.psg_registers[n]);
      }

      if (sh.version > 1) { // does the snapshot have version 2 data?
         dwModel = sh.cpc_model; // determine the model it was saved for
		  if (dwModel != CPC.model) { // different from what we're currently running?
               emulator_reset(false);
               return ERR_SNA_CPC_TYPE;		  
		  }
 /*           if (dwModel > 2) { // not one of the known models?
               emulator_reset(false);
               return ERR_SNA_CPC_TYPE;
            }
            strncpy(chPath, CPC.rom_path, sizeof(chPath)-2);
            strcat(chPath, "/");
            strncat(chPath, chROMFile[dwModel], sizeof(chPath)-1 - strlen(chPath)); // path to the required ROM image
            if ((pfileObject = fopen(chPath, "rb")) != NULL) {
               n = fread(pbROMlo, 2*16384, 1, pfileObject);
               fclose(pfileObject);
               if (!n) {
                  emulator_reset(false);
                  return ERR_CPC_ROM_MISSING;
               }
               CPC.model = dwModel;
            } else { // ROM image load failed
               emulator_reset(false);
               return ERR_CPC_ROM_MISSING;
            }
         }
		*/
      }
      if (sh.version > 2) { // does the snapshot have version 3 data?
         FDC.motor = sh.fdc_motor;
         driveA.current_track = sh.drvA_current_track;
         driveB.current_track = sh.drvB_current_track;
         CPC.printer_port = sh.printer_data ^ 0x80; // invert bit 7 again
         PSG.AmplitudeEnv = sh.psg_env_step << 1; // multiply by 2 to bring it into the 0 - 30 range
         PSG.FirstPeriod = false;
         if (sh.psg_env_direction == 0x01) { // up
            switch (PSG.RegisterAY.EnvType)
            {
               case 4:
               case 5:
               case 6:
               case 7:
               case 13:
               case 14:
               case 15:
                  PSG.FirstPeriod = true;
                  break;
            }
         } else if (sh.psg_env_direction == 0xff) { // down
            switch (PSG.RegisterAY.EnvType)
            {
               case 0:
               case 1:
               case 2:
               case 3:
               case 9:
               case 10:
               case 11:
                  PSG.FirstPeriod = true;
                  break;
            }
         }
         CRTC.addr = sh.crtc_addr[0] + (sh.crtc_addr[1] * 256);
         VDU.scanline = sh.crtc_scanline[0] + (sh.crtc_scanline[1] * 256);
         CRTC.char_count = sh.crtc_char_count[0];
         CRTC.line_count = sh.crtc_line_count;
         CRTC.raster_count = sh.crtc_raster_count;
         CRTC.vt_adjust_count = sh.crtc_vt_adjust_count;
         CRTC.hsw_count = sh.crtc_hsw_count;
         CRTC.vsw_count = sh.crtc_vsw_count;
         CRTC.flags = sh.crtc_flags[0] + (sh.crtc_flags[1] * 256);
         GateArray.int_delay = sh.ga_int_delay;
         GateArray.sl_count = sh.ga_sl_count;
         z80.int_pending = sh.z80_int_pending;
      }
   } else {
      return ERR_FILE_NOT_FOUND;
   }
   return 0;
}



int snapshot_save (char *pchFileName)
{

   t_SNA_header sh;
   int n;

   gm_memset(&sh, 0, sizeof(sh));
   gm_strcpy(sh.id, "MV - SNA");
   sh.version = 3;
// Z80
   sh.AF[1] = _A;
   sh.AF[0] = _F;
   sh.BC[1] = _B;
   sh.BC[0] = _C;
   sh.DE[1] = _D;
   sh.DE[0] = _E;
   sh.HL[1] = _H;
   sh.HL[0] = _L;
   sh.R = (_R & 0x7f) | (_Rb7 & 0x80);
   sh.I = _I;
   if (_IFF1)
      sh.IFF0 = 1;
   if (_IFF2)
      sh.IFF1 = 1;
   sh.IX[1] = _IXh;
   sh.IX[0] = _IXl;
   sh.IY[1] = _IYh;
   sh.IY[0] = _IYl;
   sh.SP[1] = z80.SP.b.h;
   sh.SP[0] = z80.SP.b.l;
   sh.PC[1] = z80.PC.b.h;
   sh.PC[0] = z80.PC.b.l;
   sh.IM = _IM;
   sh.AFx[1] = z80.AFx.b.h;
   sh.AFx[0] = z80.AFx.b.l;
   sh.BCx[1] = z80.BCx.b.h;
   sh.BCx[0] = z80.BCx.b.l;
   sh.DEx[1] = z80.DEx.b.h;
   sh.DEx[0] = z80.DEx.b.l;
   sh.HLx[1] = z80.HLx.b.h;
   sh.HLx[0] = z80.HLx.b.l;
// Gate Array
   sh.ga_pen = GateArray.pen;
   for (n = 0; n < 17; n++) { // loop for all colours + border
      sh.ga_ink_values[n] = GateArray.ink_values[n];
   }
   sh.ga_ROM_config = GateArray.ROM_config;
   sh.ga_RAM_config = GateArray.RAM_config;
// CRTC
   sh.crtc_reg_select = CRTC.reg_select;
   for (n = 0; n < 18; n++) { // loop for all CRTC registers
      sh.crtc_registers[n] = CRTC.registers[n];
   }
// ROM select
   sh.upper_ROM = GateArray.upper_ROM;
// PPI
   sh.ppi_A = PPI.portA;
   sh.ppi_B = PPI.portB;
   sh.ppi_C = PPI.portC;
   sh.ppi_control = PPI.control;
// PSG
   sh.psg_reg_select = PSG.reg_select;
   for (n = 0; n < 16; n++) { // loop for all PSG registers
      sh.psg_registers[n] = PSG.RegisterAY.Index[n];
   }

   sh.ram_size[0] = CPC.ram_size & 0xff;
   sh.ram_size[1] = (CPC.ram_size >> 8) & 0xff;
// version 2 info
   sh.cpc_model = CPC.model;
// version 3 info
   sh.fdc_motor = FDC.motor;
   sh.drvA_current_track = driveA.current_track;
   sh.drvB_current_track = driveB.current_track;
   sh.printer_data = CPC.printer_port ^ 0x80; // invert bit 7 again
   sh.psg_env_step = PSG.AmplitudeEnv >> 1; // divide by 2 to bring it into the 0 - 15 range
   if (PSG.FirstPeriod) {
      switch (PSG.RegisterAY.EnvType)
      {
         case 0:
         case 1:
         case 2:
         case 3:
         case 8:
         case 9:
         case 10:
         case 11:
            sh.psg_env_direction = 0xff; // down
            break;
         case 4:
         case 5:
         case 6:
         case 7:
         case 12:
         case 13:
         case 14:
         case 15:
            sh.psg_env_direction = 0x01; // up
            break;
      }
   } else {
      switch (PSG.RegisterAY.EnvType)
      {
         case 0:
         case 1:
         case 2:
         case 3:
         case 4:
         case 5:
         case 6:
         case 7:
         case 9:
         case 11:
         case 13:
         case 15:
            sh.psg_env_direction = 0x00; // hold
            break;
         case 8:
         case 14:
            sh.psg_env_direction = 0xff; // down
            break;
         case 10:
         case 12:
            sh.psg_env_direction = 0x01; // up
            break;
      }
   }
   sh.crtc_addr[0] = CRTC.addr & 0xff;
   sh.crtc_addr[1] = (CRTC.addr >> 8) & 0xff;
   sh.crtc_scanline[0] = VDU.scanline & 0xff;
   sh.crtc_scanline[1] = (VDU.scanline >> 8) & 0xff;
   sh.crtc_char_count[0] = CRTC.char_count;
   sh.crtc_line_count = CRTC.line_count;
   sh.crtc_raster_count = CRTC.raster_count;
   sh.crtc_vt_adjust_count = CRTC.vt_adjust_count;
   sh.crtc_hsw_count = CRTC.hsw_count;
   sh.crtc_vsw_count = CRTC.vsw_count;
   sh.crtc_flags[0] = CRTC.flags & 0xff;
   sh.crtc_flags[1] = (CRTC.flags >> 8) & 0xff;
   sh.ga_int_delay = GateArray.int_delay;
   sh.ga_sl_count = GateArray.sl_count;
   sh.z80_int_pending = z80.int_pending;

   	char path[50];
	gm_sprintf(path,"gp:\\gpmm\\amstrad\\snaps\\%s", (char*)pchFileName);
   
  // if ((pfileObject = fopen(pchFileName, "wb")) != NULL) {
  	  if(GpFileCreate(path,ALWAYS_CREATE,&pfileObject)==SM_OK)
       {
        GpFileClose(pfileObject);
		if(GpFileOpen(path,OPEN_W,&pfileObject)==SM_OK){


      //if (fwrite(&sh, sizeof(sh), 1, pfileObject) != 1) { // write snapshot header
	  GpFileWrite(pfileObject,&sh,sizeof(sh)); 
//      if (fwrite(pbRAM, CPC.ram_size*1024, 1, pfileObject) != 1) { // write memory contents to snapshot file
	  GpFileWrite(pfileObject,pbRAM,CPC.ram_size*1024);
      GpFileClose(pfileObject);
	  //GpFATUpdate("GP://");
   } else {
      return ERR_SNA_WRITE;
   }
}else {
      return ERR_SNA_WRITE;
   }
   return 0;
}



void dsk_eject (t_drive *drive)
{
   cpc_dword track, side;

   for (track = 0; track < DSK_TRACKMAX; track++) { // loop for all tracks
      for (side = 0; side < DSK_SIDEMAX; side++) { // loop for all sides
         if (drive->track[track][side].data) { // track is formatted?
//            free(drive->track[track][side].data); // release memory allocated for this track
              gm_free(drive->track[track][side].data);
         }
      }
   }
   cpc_dword dwTemp = drive->current_track; // save the drive head position
   gm_memset(drive, 0, sizeof(t_drive)); // clear drive info structure
   drive->current_track = dwTemp;
}



int dsk_load (char *pchFileName, t_drive *drive, char chID)
{
   int iRetCode;
   cpc_dword dwTrackSize, track, side, sector, dwSectorSize, dwSectors;
   cpc_byte *pbPtr, *pbDataPtr, *pbTempPtr, *pbTrackSizeTable;
   ulong leido;
   
   iRetCode = 0;
   
   //SISTEMA DE ARCHIVOS DE LA GP
   #ifndef DEBUG
    // GpFatInit();
   #endif
   dsk_eject(drive);
//  if ((pfileObject = fopen(pchFileName, "rb")) != NULL) {
   if (GpFileOpen (pchFileName, OPEN_R, &pfileObject)==SM_OK) {
//      fread(pbGPBuffer, 0x100, 1, pfileObject); // read DSK header
      GpFileRead ((F_HANDLE)pfileObject, (char*)pbGPBuffer, (int) 0x100, (ulong*)&leido);

      pbPtr = pbGPBuffer;
      if (gm_memcmp(pbPtr, "MV - CPC", 8) == 0) { // normal DSK image?
         drive->tracks = *(pbPtr + 0x30); // grab number of tracks
         if (drive->tracks > DSK_TRACKMAX) { // compare against upper limit
            drive->tracks = DSK_TRACKMAX; // limit to maximum
         }
         drive->sides = *(pbPtr + 0x31); // grab number of sides
         if (drive->sides > DSK_SIDEMAX) { // abort if more than maximum
            iRetCode = ERR_DSK_SIDES;
            goto exit;
         }
         dwTrackSize = (*(pbPtr + 0x32) + (*(pbPtr + 0x33) << 8)) - 0x100; // determine track size in bytes, minus track header

         drive->sides--; // zero base number of sides

         for (track = 0; track < drive->tracks; track++) { // loop for all tracks

            for (side = 0; side <= drive->sides; side++) { // loop for all sides
//               fread(pbGPBuffer+0x100, 0x100, 1, pfileObject); // read track header
               GpFileRead ((F_HANDLE)pfileObject, pbGPBuffer+0x100, 0x100, &leido);
               pbPtr = pbGPBuffer + 0x100;

               if (gm_memcmp(pbPtr, "Track-Info", 10) != 0) { // abort if ID does not match
                  iRetCode = ERR_DSK_INVALID;//*(pbGPBuffer+ 0x100) + *pbPtr;
                  goto exit;
               }/*else{
                  iRetCode = *(pbGPBuffer+ 0x100);//ERR_DSK_INVALID+pase;
                  goto exit;
			   }*/
               dwSectorSize = 0x80 << *(pbPtr + 0x14); // determine sector size in bytes
               dwSectors = *(pbPtr + 0x15); // grab number of sectors
               if (dwSectors > DSK_SECTORMAX) { // abort if sector count greater than maximum
                  iRetCode = ERR_DSK_SECTORS;
                  goto exit;
               }

               drive->track[track][side].sectors = dwSectors; // store sector count
               drive->track[track][side].size = dwTrackSize; // store track size

//               drive->track[track][side].data = (cpc_byte *)malloc(dwTrackSize); // attempt to allocate the required memory
               drive->track[track][side].data = (cpc_byte*) gm_zi_malloc(dwTrackSize); 
               
               if (drive->track[track][side].data == NULL) { // abort if not enough
                  iRetCode = ERR_OUT_OF_MEMORY;
                  goto exit;
               }
               pbDataPtr = drive->track[track][side].data; // pointer to start of memory buffer
               pbTempPtr = pbDataPtr; // keep a pointer to the beginning of the buffer for the current track
               for (sector = 0; sector < dwSectors; sector++) { // loop for all sectors
                  gm_memcpy(drive->track[track][side].sector[sector].CHRN, (pbPtr + 0x18), 4); // copy CHRN
                  gm_memcpy(drive->track[track][side].sector[sector].flags, (pbPtr + 0x1c), 2); // copy ST1 & ST2
                  drive->track[track][side].sector[sector].size = dwSectorSize;
                  drive->track[track][side].sector[sector].data = pbDataPtr; // store pointer to sector data
                  pbDataPtr += dwSectorSize;

                  pbPtr += 8;
               }
//               if (!fread(pbTempPtr, dwTrackSize, 1, pfileObject)) { // read entire track data in one go
               if(GpFileRead ((F_HANDLE)pfileObject, pbTempPtr, dwTrackSize, &leido)!=SM_OK) {
                  iRetCode = ERR_DSK_INVALID;
                  goto exit;
               }

            }
         }
         drive->altered = 0; // disk is as yet unmodified
      } else {
         if (gm_memcmp(pbPtr, "EXTENDED", 8) == 0) { // extended DSK image?
            drive->tracks = *(pbPtr + 0x30); // number of tracks
            if (drive->tracks > DSK_TRACKMAX) {  // limit to maximum possible
               drive->tracks = DSK_TRACKMAX;
            }
            drive->random_DEs = *(pbPtr + 0x31) & 0x80; // simulate random Data Errors?
            drive->sides = *(pbPtr + 0x31) & 3; // number of sides
            if (drive->sides > DSK_SIDEMAX) { // abort if more than maximum
               iRetCode = ERR_DSK_SIDES;
               goto exit;
            }
            pbTrackSizeTable = pbPtr + 0x34; // pointer to track size table in DSK header
            drive->sides--; // zero base number of sides
            for (track = 0; track < drive->tracks; track++) { // loop for all tracks
               for (side = 0; side <= drive->sides; side++) { // loop for all sides
                  dwTrackSize = (*pbTrackSizeTable++ << 8); // track size in bytes
                  if (dwTrackSize != 0) { // only process if track contains data
                     dwTrackSize -= 0x100; // compensate for track header
//                     fread(pbGPBuffer+0x100, 0x100, 1, pfileObject); // read track header
                     GpFileRead ((F_HANDLE)pfileObject, pbGPBuffer+0x100, 0x100, &leido);
                     pbPtr = pbGPBuffer + 0x100;
                     if (gm_memcmp(pbPtr, "Track-Info", 10) != 0) { // valid track header?
                        iRetCode = ERR_DSK_INVALID;
                        goto exit;
                     }
                     dwSectors = *(pbPtr + 0x15); // number of sectors for this track
                     if (dwSectors > DSK_SECTORMAX) { // abort if sector count greater than maximum
                        iRetCode = ERR_DSK_SECTORS;
                        goto exit;
                     }
                     drive->track[track][side].sectors = dwSectors; // store sector count
                     drive->track[track][side].size = dwTrackSize; // store track size
                     drive->track[track][side].data = (cpc_byte *)gm_zi_malloc(dwTrackSize); // attempt to allocate the required memory
                     if (drive->track[track][side].data == NULL) { // abort if not enough
                        iRetCode = ERR_OUT_OF_MEMORY;
                        goto exit;
                     }
                     pbDataPtr = drive->track[track][side].data; // pointer to start of memory buffer
                     pbTempPtr = pbDataPtr; // keep a pointer to the beginning of the buffer for the current track
                     for (sector = 0; sector < dwSectors; sector++) { // loop for all sectors
                        gm_memcpy(drive->track[track][side].sector[sector].CHRN, (pbPtr + 0x18), 4); // copy CHRN
                        gm_memcpy(drive->track[track][side].sector[sector].flags, (pbPtr + 0x1c), 2); // copy ST1 & ST2
                        dwSectorSize = *(pbPtr + 0x1e) + (*(pbPtr + 0x1f) << 8); // sector size in bytes
                        drive->track[track][side].sector[sector].size = dwSectorSize;
                        drive->track[track][side].sector[sector].data = pbDataPtr; // store pointer to sector data
                        pbDataPtr += dwSectorSize;
                        pbPtr += 8;
                     }
//                     if (!fread(pbTempPtr, dwTrackSize, 1, pfileObject)) { // read entire track data in one go
                     if(GpFileRead ((F_HANDLE)pfileObject, pbTempPtr, dwTrackSize, &leido)!=SM_OK) {
                        iRetCode = ERR_DSK_INVALID;
                        goto exit;
                     }
                  } else {
                     gm_memset(&drive->track[track][side], 0, sizeof(t_track)); // track not formatted
                  }
               }
            }
            drive->altered = 0; // disk is as yet unmodified
         } else {
            iRetCode = ERR_DSK_INVALID; // file could not be identified as a valid DSK
         }
      }
/*    {
         char *pchTmpBuffer = new char[MAX_LINE_LEN];
         LoadString(hAppInstance, MSG_DSK_LOAD, chMsgBuffer, sizeof(chMsgBuffer));
         snprintf(pchTmpBuffer, _MAX_PATH-1, chMsgBuffer, chID, chID == 'A' ? CPC.drvA_file : CPC.drvB_file);
         add_message(pchTmpBuffer);
         delete [] pchTmpBuffer;
      } */
exit:
      GpFileClose((F_HANDLE)pfileObject);
	  #ifndef DEBUG
	  //GpFATUpdate("GP://");
	  #endif
   } else {
      iRetCode = ERR_FILE_NOT_FOUND;
   }

   if (iRetCode != 0) { // on error, 'eject' disk from drive
      dsk_eject(drive);
   }
   return iRetCode;
}

//SAVE CODE READY :-D

int dsk_save (char *pchFileName, t_drive *drive, char chID)
{
   t_DSK_header dh;
   t_track_header th;
   cpc_dword track, side, pos, sector;

//   if ((pfileObject = fopen(pchFileName, "wb")) != NULL) {
   if (GpFileOpen (pchFileName, OPEN_W, &pfileObject)==SM_OK) {   
      gm_memset(&dh, 0, sizeof(dh));
      gm_strcpy(dh.id, "EXTENDED CPC DSK File\r\nDisk-Info\r\n");
      gm_strcpy(dh.unused1, "Pituka-GP\r\n");
      dh.tracks = drive->tracks;
      dh.sides = (drive->sides+1) | (drive->random_DEs); // correct side count and indicate random DEs, if necessary
      pos = 0;
      for (track = 0; track < drive->tracks; track++) { // loop for all tracks
         for (side = 0; side <= drive->sides; side++) { // loop for all sides
            if (drive->track[track][side].size) { // track is formatted?
               dh.track_size[pos] = (drive->track[track][side].size + 0x100) >> 8; // track size + header in bytes
            }
            pos++;
         }
      }
//      if (!fwrite(&dh, sizeof(dh), 1, pfileObject)) { // write header to file
      if(GpFileWrite ((F_HANDLE)pfileObject, &dh, sizeof(dh))!=SM_OK) {
         GpFileClose((F_HANDLE)pfileObject);
         return ERR_DSK_WRITE;
      }

      gm_memset(&th, 0, sizeof(th));
      gm_strcpy(th.id, "Track-Info\r\n");
      for (track = 0; track < drive->tracks; track++) { // loop for all tracks
         for (side = 0; side <= drive->sides; side++) { // loop for all sides
            if (drive->track[track][side].size) { // track is formatted?
               th.track = track;
               th.side = side;
               th.bps = 2;
               th.sectors = drive->track[track][side].sectors;
               th.gap3 = 0x4e;
               th.filler = 0xe5;
               for (sector = 0; sector < th.sectors; sector++) {
                  gm_memcpy(&th.sector[sector][0], drive->track[track][side].sector[sector].CHRN, 4); // copy CHRN
                  gm_memcpy(&th.sector[sector][4], drive->track[track][side].sector[sector].flags, 2); // copy ST1 & ST2
                  th.sector[sector][6] = drive->track[track][side].sector[sector].size & 0xff;
                  th.sector[sector][7] = (drive->track[track][side].sector[sector].size >> 8) & 0xff; // sector size in bytes
               }
//               if (!fwrite(&th, sizeof(th), 1, pfileObject)) { // write track header
               if(GpFileWrite ((F_HANDLE)pfileObject, &th, sizeof(th))!=SM_OK) {
                  GpFileClose((F_HANDLE)pfileObject);
                  return ERR_DSK_WRITE;
               }
//               if (!fwrite(drive->track[track][side].data, drive->track[track][side].size, 1, pfileObject)) { // write track data
               if(GpFileWrite ((F_HANDLE)pfileObject, drive->track[track][side].data, drive->track[track][side].size)!=SM_OK) {
                  GpFileClose((F_HANDLE)pfileObject);
                  return ERR_DSK_WRITE;
               }
            }
         }
      }
      GpFileClose((F_HANDLE)pfileObject);
   } else {
      return ERR_DSK_WRITE; // write attempt failed
   }

/* char *pchTmpBuffer = new char[MAX_LINE_LEN];
   LoadString(hAppInstance, MSG_DSK_SAVE, chMsgBuffer, sizeof(chMsgBuffer));
   snprintf(pchTmpBuffer, _MAX_PATH-1, chMsgBuffer, chID, chID == 'A' ? CPC.drvA_file : CPC.drvB_file);
   add_message(pchTmpBuffer);
   delete [] pchTmpBuffer; */
   return 0;
}

//FORMAT CODE READY :?

int dsk_format (t_drive *drive, int iFormat)
{
   cpc_dword track, side, sector;
    
   int iRetCode = 0;
   drive->tracks = disk_format[iFormat].tracks;
   if (drive->tracks > DSK_TRACKMAX) { // compare against upper limit
      drive->tracks = DSK_TRACKMAX; // limit to maximum
   }
   drive->sides = disk_format[iFormat].sides;
   if (drive->sides > DSK_SIDEMAX) { // abort if more than maximum
      iRetCode = ERR_DSK_SIDES;
      goto exit;
   }
   drive->sides--; // zero base number of sides
   for ( track = 0; track < drive->tracks; track++) { // loop for all tracks
      for ( side = 0; side <= drive->sides; side++) { // loop for all sides
         cpc_dword dwSectorSize = 0x80 << disk_format[iFormat].sector_size; // determine sector size in bytes
         cpc_dword dwSectors = disk_format[iFormat].sectors;
         if (dwSectors > DSK_SECTORMAX) { // abort if sector count greater than maximum
            iRetCode = ERR_DSK_SECTORS;
            goto exit;
         }
         cpc_dword dwTrackSize = dwSectorSize * dwSectors; // determine track size in bytes, minus track header
         drive->track[track][side].sectors = dwSectors; // store sector count
         drive->track[track][side].size = dwTrackSize; // store track size
         drive->track[track][side].data = (cpc_byte *)gm_zi_malloc(dwTrackSize); // attempt to allocate the required memory
         if (drive->track[track][side].data == NULL) { // abort if not enough
            iRetCode = ERR_OUT_OF_MEMORY;
            goto exit;
         }
         cpc_byte *pbDataPtr = drive->track[track][side].data; // pointer to start of memory buffer
         cpc_byte *pbTempPtr = pbDataPtr; // keep a pointer to the beginning of the buffer for the current track
         cpc_byte CHRN[4];
         CHRN[0] = (byte)track;
         CHRN[1] = (byte)side;
         CHRN[3] = (byte)disk_format[iFormat].sector_size;
         for ( sector = 0; sector < dwSectors; sector++) { // loop for all sectors
            CHRN[2] = disk_format[iFormat].sector_ids[side][sector];
            gm_memcpy(drive->track[track][side].sector[sector].CHRN, CHRN, 4); // copy CHRN
            drive->track[track][side].sector[sector].size = dwSectorSize;
            drive->track[track][side].sector[sector].data = pbDataPtr; // store pointer to sector data
            pbDataPtr += dwSectorSize;
         }
         gm_memset(pbTempPtr, disk_format[iFormat].filler_byte, dwTrackSize);
      }
   }
   drive->altered = 1; // flag disk as having been modified

exit:
   if (iRetCode != 0) { // on error, 'eject' disk from drive
      dsk_eject(drive);
   }
   return iRetCode;
}


//NO NEED

void tape_eject (void)
{
/*
   free(pbTapeImage);
   pbTapeImage = NULL;
   */
}


//NO NEED

int tape_insert (char *pchFileName)
{
   return 0;
}


//NO NEED

int tape_insert_voc (char *pchFileName)
{
   return 0;
}



void vdu_init (bool bolInit)
{
//PARA Q ES ESTO?!?!? xD

   if (CPC.scr_fs_width > (CPC_VISIBLE_SCR_WIDTH * dwXScale)) {
	   //LCD.x = (320 - ( 384 * 1)) /2 -> -32
      video_rect.x = (CPC.scr_fs_width - (CPC_VISIBLE_SCR_WIDTH * dwXScale)) / 2;
      video_rect.w = 0; // not used
      back_rect.x = 0;
	  //Buffer.w = 384 * 1 -> 384
      back_rect.w = CPC_VISIBLE_SCR_WIDTH * dwXScale;
   } else {
   //ENTRA AKI por q scr_fs_width es menor...
      video_rect.x = 0;
      video_rect.w = 0; // not used
	// Buffer.x = ((384*1) - 320) / 2 -> 32
      back_rect.x = ((CPC_VISIBLE_SCR_WIDTH * dwXScale) - CPC.scr_fs_width) / 2;
	// Buffer.w = 320
      back_rect.w = CPC.scr_fs_width;
   }

   if (CPC.scr_fs_height > (CPC_VISIBLE_SCR_HEIGHT * dwYScale)) {
      video_rect.y = (CPC.scr_fs_height - (CPC_VISIBLE_SCR_HEIGHT * dwYScale)) / 2;
      video_rect.h = 0; // not used
      back_rect.y = 0;
      back_rect.h = CPC_VISIBLE_SCR_HEIGHT * dwYScale;
    } else {
	   //ENTRA AKI por q scr_fs_height es menor... 240 > 272
      video_rect.y = 0;
      video_rect.h = 0; // not used
	  //Buffer.y = ((272*1) - 240) / 2 -> 16
      back_rect.y = ((CPC_VISIBLE_SCR_HEIGHT * dwYScale) - CPC.scr_fs_height) / 2;
	  //Buffer.h = 240
      back_rect.h = CPC.scr_fs_height;
    }

	//PARA Q SE VEA BIEN CENTRADO ARRIBA Y ABAJO
	//AL MODIFICAR LAS VARIABLES DE ARRIBA HAY Q DARLE +2 a 
	//back_rect.y para q este centrado en pantalla :D
	if(back_rect.y==16)
		back_rect.y=18;
	
	//LCD.x .y .w .h = 0
	//Buffer.x = 32
	//Buffer.w = 320
	//Buffer.y = 16
	//Buffer.h = 240
	
	/*
   if (bolInit) {
      VDU.hstart = 7;
	  //VDU.h = 384 / 8 -> 48
      VDU.hwidth = CPC_VISIBLE_SCR_WIDTH / 8;
      VDU.vstart = 27;
	  //VDU.vh = 272
      VDU.vheight = CPC_VISIBLE_SCR_HEIGHT;
   }
   */
   
   if (bolInit) {
  /*       VDU.hstart = 7;
      VDU.hwidth = CPC_VISIBLE_SCR_WIDTH / 8;
      VDU.vstart = 27;
      VDU.vheight = CPC_VISIBLE_SCR_HEIGHT;
*/
      VDU.hstart = 11;
	  //VDU.h = 384 / 8 -> 48
      VDU.hwidth = CPC_VISIBLE_SCR_WIDTH / 8;
      VDU.vstart = 46;
	  //VDU.vh = 272
      VDU.vheight = CPC_VISIBLE_SCR_HEIGHT;
   }
   
}

//NO NEED

int emulator_patch_ROM (void)
{

   return 0;
}



void emulator_reset (bool bolMF2Reset)
{
   int n, val1, val2;

//PituKa
	  reiniciado=1;
	  spool=1;
   
// Z80
   gm_memset(&z80, 0, sizeof(z80)); // clear all Z80 registers and support variables
   _IX =
   _IY = 0xffff; // IX and IY are FFFF after a reset!
   _F = Zflag; // set zero flag
   z80.break_point = 0xffffffff; // clear break point

// CPC
   CPC.cycle_count = CYCLE_COUNT_INIT;
   gm_memset(keyboard_matrix, 0xff, sizeof(keyboard_matrix)); // clear CPC keyboard matrix
   CPC.tape_motor = 0;
   CPC.tape_play_button = 0;
   CPC.printer_port = 0xff;

// CRTC
   gm_memset(&CRTC, 0, sizeof(CRTC)); // clear CRTC data structure
   for (n = 0; n < 14; n++) { // program CRTC with 'valid' data
      CRTC.registers[n] = CRTC_values[(CPC.jumpers & 0x10)>>4][n];
   }
   CRTC.flags = HDT_flag | VDT_flag;
   CRTC.hsw =
   CRTC.hsw_active = CRTC.registers[3] & 0x0f;
   CRTC.vsw = CRTC.registers[3] >> 4;
   CRTC.vt_adjust = CRTC.registers[5] & 0x1f;
 //  CRTC.skew = (CRTC.registers[8] >> 4) & 3;
 //  if (CRTC.skew == 3) { // no output?
      CRTC.skew = 0xff;
  // }
   CRTC.max_raster = CRTC.registers[9] << 3;
   val1 = CRTC.registers[12] & 0x3f;
   val2 = val1 & 0x0f; // isolate screen size
   val1 = (val1 << 1) & 0x60; // isolate CPC RAM bank
   val2 |= val1; // combine
   CRTC.addr =
   CRTC.requested_addr = (CRTC.registers[13] + (val2 << 8)) << 1;
   CRTC.last_hdisp = 0x28;

// VDU
   gm_memset(&VDU, 0, sizeof(VDU)); // clear VDU data structure
   VDU.hsw =
   VDU.hsw_active = 4;
   VDU.scanline_min = 272; //240;
   vdu_init(true);

// Gate Array
   gm_memset(&GateArray, 0, sizeof(GateArray)); // clear GA data structure
   GateArray.scr_mode =
   GateArray.requested_scr_mode = (void(*)(cpc_dword))mode_handler[1]; // set to normal mode 1 handler
   GateArray.scr_border = (void(*)(void))border_handler; // set to normal border handler
   ga_init_banking();

// PPI
   gm_memset(&PPI, 0, sizeof(PPI)); // clear PPI data structure

// PSG
   PSG.control = 0;
   ResetAYChipEmulation();
   
   //Pruebas de PSG
   
 //gm_memset(ay_registers,0,16); 
 //ay_current_reg=0;

 //sound_init();
 //sound_ay_reset(0, 70908);//model<ZX_128?69888:70908);



// FDC
   gm_memset(&FDC, 0, sizeof(FDC)); // clear FDC data structure
   FDC.phase = CMD_PHASE;
   FDC.flags = STATUSDRVA_flag | STATUSDRVB_flag;

// memory
   if (bolMF2Reset) {
      gm_memset(pbRAM, 0, 64*1024); // clear only the first 64K of CPC memory
   } else {
      gm_memset(pbRAM, 0, CPC.ram_size*1024); // clear all memory used for CPC RAM
      if (pbMF2ROM) {
         gm_memset(pbMF2ROM+8192, 0, 8192); // clear the MF2's RAM area
      }
   }
   for (n = 0; n < 4; n++) { // initialize active read/write bank configuration
      membank_read[n] = membank_config[0][n];
      membank_write[n] = membank_config[0][n];
   }
   membank_read[0] = pbROMlo; // 'page in' lower ROM
   membank_read[3] = pbROMhi; // 'page in' upper ROM

// Multiface 2
   dwMF2Flags = 0;
   dwMF2ExitAddr = 0xffffffff; // clear MF2 return address
   if ((pbMF2ROM) && (pbMF2ROMbackup)) {
      gm_memcpy(pbMF2ROM, pbMF2ROMbackup, 8192); // copy the MF2 ROM to its proper place
   }
   
   
   //CURSOR
   puntero.px=90;
   puntero.py=32;
   puntero.x=8;
   puntero.y=2;
}



int emulator_init (void)
{
   int iErr; //, iRomNum;
  // char chPath[_MAX_PATH + 1];
  // cpc_byte *pchRomData;
/*
   pbGPBuffer = new cpc_byte [128*1024]; // attempt to allocate the general purpose buffer
   pbRAM = new cpc_byte [CPC.ram_size*1024]; // allocate memory for desired amount of RAM
   pbROMlo = new cpc_byte [32*1024]; // allocate memory for 32K of ROM
*/ 
   pbRAM = (cpc_byte*) gm_zi_malloc(CPC.ram_size*1024);
   pbGPBuffer = (cpc_byte*) gm_zi_malloc(128*1024);
   //pbROMlo = (cpc_byte*) gm_zi_malloc(32*1024);  //ya esta creado con OS...
   pbROMlo=(cpc_byte *)&OS[0]; // CPC 6128

   if ((!pbGPBuffer) || (!pbRAM) ){ //|| (!pbROMlo)) {
      return ERR_OUT_OF_MEMORY;
   }
   
   pbROMhi = pbExpansionROM = (cpc_byte *)pbROMlo + 16384;
   gm_memset(memmap_ROM, 0, sizeof(memmap_ROM[0]) * 256); // clear the expansion ROM map
   ga_init_banking(); // init the CPC memory banking map

	if ((iErr = emulator_patch_ROM())) {
      return iErr;
   }
      
  /* for (iRomNum = 2; iRomNum < 16; iRomNum++)
	   CPC.rom_file[iRomNum][0] = 0;
   */
   memmap_ROM[7] = (cpc_byte*)&AMSDOS[0];
	   
   
   //CPC.rom_mf2[0] = 0;
   CPC.mf2 = 0;

   emulator_reset(false);
   CPC.paused &= ~1;
   
   return 0;
}




void emulator_shutdown (void)
{
 
   
   pbMF2ROM = NULL;

   memmap_ROM[7]= NULL;

   pbROMlo=NULL;
   gm_free(pbRAM);
   gm_free(pbGPBuffer);
   
}


//NO NEED

int printer_start (void)
{
   return 0;
}


//NO NEED

void printer_stop (void)
{
   if (pfoPrinter) {
      GpFileClose((F_HANDLE)pfoPrinter);
   }
   pfoPrinter = NULL;
}

/*
void audio_update (void *userdata, u8 *stream, int len)
{
CPC.snd_bufferptr=(byte *)stream;
while(len--) PSG.Synthesizer();

//stream=(u8 *)pbSndBuffer;
//PSG.Synthesizer();
  *//* gm_memcpy((void *)stream, pbSndStream, len);
   pbSndStream += len;
   if (pbSndStream >= pbSndBufferEnd) {
      pbSndStream = pbSndBuffer;
   }
*//*
}
*/


int audio_align_samples (int given)
{
   int actual = 1;
   while (actual < given) {
      actual <<= 2;
   }
   return actual; // return the closest match as 2^n
}




int audio_init (void)
{
  // SDL_AudioSpec *desired, *obtained;
	int n=0;
	
   if (!CPC.snd_enabled) {
      return 0;
   }

/*
   if (!sound_enabled) {
      return 0;
   }
   */
/*
   desired = (SDL_AudioSpec *)malloc(sizeof(SDL_AudioSpec));
   obtained = (SDL_AudioSpec *)malloc(sizeof(SDL_AudioSpec));

   desired->freq = freq_table[CPC.snd_playback_rate];
   desired->format = CPC.snd_bits ? AUDIO_S16LSB : AUDIO_S8;
   desired->channels = CPC.snd_stereo+1;
   desired->samples = audio_align_samples(desired->freq / 50); // desired is 20ms at the given frequency
   desired->callback = audio_update;
   desired->userdata = NULL;

   if (SDL_OpenAudio(desired, obtained) < 0) {
      fprintf(stderr, "Could not open audio: %s\n", SDL_GetError());
      return 1;
   }

   free(desired);
   */
   /*
   typedef struct GPSOUNDBUF
  {
    PCM_SR freq;              // Taken from gpmm.h 
    PCM_BIT format;           // Taken from gpmm.h 
    unsigned int samples;     // Buffer length (in samples) 
    void * userdata;         // Userdata which gets passed to the callback function 
    void (*callback)(         // Callback function (just like in SDL) 
          void * userdata,    // GPSOUNDBUF.userdata 
          u8 * stream,        // Pointer to the buffer which needs to be refilled
          int len);           //Length of the buffer in bytes 
    unsigned int pollfreq;    // Frequency of the timer interrupt which polls the playing position
                              // * recommended value: 2*(playingfreq in Hz/GPSOUNDBUF.samples) 
    unsigned int samplesize;  // Size of one sample (8bit mono->1, 16bit stereo->4) - don't touch this 
  } GPSOUNDBUF;
  
  RLYEH v2
  
  sndbuf.freq=PCM_M22;  
  sndbuf.format=PCM_8BIT; 
  sndbuf.samples=22050/50; 
  sndbuf.userdata=NULL;
  sndbuf.callback=sound_frame_8;
  sndbuf.pollfreq=5000/60;

  
*/
   sonido.freq=PCM_M22;
   sonido.format=PCM_8BIT;
   sonido.samples=367; 
   sonido.callback= audio_update;//sound_frame_8;
   sonido.userdata=NULL;
   sonido.pollfreq= 100;//2*(22050/1024);
   sonido.samplesize = 1;
   
   
   GpSoundBufStart( &sonido );

   
   //audio_spec = obtained;

   CPC.snd_buffersize =367; //audio_spec->size; // size is samples * channels * bytes per sample (1 or 2)
   //active_track->data = (unsigned char *)gm_malloc(track_size+sizeof(unsigned char));
   pbSndBuffer =  (cpc_byte*) buffer;//(cpc_byte *)gm_malloc(CPC.snd_buffersize*2); // allocate a ring buffer with 10 segments
   pbSndBufferEnd = (unsigned char*) pbSndBuffer + (CPC.snd_buffersize*2); //antes valia 6???
   //soundBuf.samplesize*soundBuf.samples*2
   pbSndStream = (unsigned char*) pbSndBuffer; // put the play cursor at the start
   
   //Esto ya lo hace GpSoundBufStart ()
   //gm_memset(pbSndBuffer, 0, CPC.snd_buffersize*2); //antes valia 6??
/*
   CPC.snd_bufferptr = pbSndBuffer + (CPC.snd_buffersize*3); // init write cursor

   dwSndMinSafeDist = CPC.snd_buffersize*2; // the closest together the cursors may be
   dwSndMaxSafeDist = CPC.snd_buffersize*4; // the farthest apart the cursors may be
*/

	  dwSndMinSafeDist = (CPC.snd_buffersize/2);
		CPC.snd_bufferptr = (unsigned char*)pbSndBuffer + (dwSndMinSafeDist/2);
	  dwSndMaxSafeDist = CPC.snd_buffersize+(dwSndMinSafeDist);

	  

   InitAY();


   for ( n = 0; n < 16; n++) {
      SetAYRegister(n, PSG.RegisterAY.Index[n]); // init sound emulation with valid values
   }

   //CPC.snd_enabled=0;
   
   //sound_enabled = 1;
   
   return 0;
}



void audio_shutdown (void)
{
//LIBERAR sound_buffer
  
 // GpSoundBufStop();
  
}



void audio_pause (void)
{
   if (CPC.snd_enabled) {
  //GpSoundBufStop();
   }
}



void audio_resume (void)
{

   if (CPC.snd_enabled) {
//GpSoundBufStart ( &sonido );
   }
}




void video_init_tables (void)
{
   int idx, n, p1, p2, p3, p4;

   idx = 0;
   for (n = 0; n < 256; n++) { // calculate mode0 byte-to-pixel translation table
      p1 = ((n & 0x80) >> 7) + ((n & 0x08) >> 2) + ((n & 0x20) >> 3) + ((n & 0x02) << 2);
      p2 = ((n & 0x40) >> 6) + ((n & 0x04) >> 1) + ((n & 0x10) >> 2) + ((n & 0x01) << 3);
      mode0_table[idx++] = p1;
      mode0_table[idx++] = p2;
   }

   idx = 0;
   for (n = 0; n < 256; n++) { // calculate mode1 byte-to-pixel translation table
      p1 = ((n & 0x80) >> 7) + ((n & 0x08) >> 2);
      p2 = ((n & 0x40) >> 6) + ((n & 0x04) >> 1);
      p3 = ((n & 0x20) >> 5) +  (n & 0x02);
      p4 = ((n & 0x10) >> 4) + ((n & 0x01) << 1);
      mode1_table[idx++] = p1;
      mode1_table[idx++] = p2;
      mode1_table[idx++] = p3;
      mode1_table[idx++] = p4;
   }
}


int video_set_palette (void)
{
   //SDL_Color colours[256];
   
/*   typedef unsigned short GP_PALETTEENTRY;
typedef struct tag_GP_LOGPALENTRY{
	unsigned char peRed;
	unsigned char peGreen;
	unsigned char peBlue;
	unsigned char peFlags;
}GP_LOGPALENTRY; 

static double colours_rgb[32][3] = {
   { 0.5, 0.5, 0.5 }, { 0.5, 0.5, 0.5 },{ 0.0, 1.0, 0.5 }, { 1.0, 1.0, 0.5 },
   { 0.0, 0.0, 0.5 }, { 1.0, 0.0, 0.5 },{ 0.0, 0.5, 0.5 }, { 1.0, 0.5, 0.5 },
   { 1.0, 0.0, 0.5 }, { 1.0, 1.0, 0.5 },{ 1.0, 1.0, 0.0 }, { 1.0, 1.0, 1.0 },
   { 1.0, 0.0, 0.0 }, { 1.0, 0.0, 1.0 },{ 1.0, 0.5, 0.0 }, { 1.0, 0.5, 1.0 },
   { 0.0, 0.0, 0.5 }, { 0.0, 1.0, 0.5 },{ 0.0, 1.0, 0.0 }, { 0.0, 1.0, 1.0 },
   { 0.0, 0.0, 0.0 }, { 0.0, 0.0, 1.0 },{ 0.0, 0.5, 0.0 }, { 0.0, 0.5, 1.0 },
   { 0.5, 0.0, 0.5 }, { 0.5, 1.0, 0.5 },{ 0.5, 1.0, 0.0 }, { 0.5, 1.0, 1.0 },
   { 0.5, 0.0, 0.0 }, { 0.5, 0.0, 1.0 },{ 0.5, 0.5, 0.0 }, { 0.5, 0.5, 1.0 }
};*/
/*
PALETTE cpcpalpc=
{
        {0,0,0},        {31,31,31},        {31,31,31},        {0,63,31},
        {63,63,31},        {0,0,31},        {63,0,31},        {0,31,31},
        {63,31,31},        {63,0,31},        {63,63,31},        {63,63,0},
        {63,63,63},        {63,0,0},        {0,63,63},        {63,31,0},
        {63,31,63},       {0,0,31},        {0,63,31},        {0,63,0},
        {0,63,63},        {0,0,0},        {0,0,63},        {0,31,0},
        {0,31,63},        {31,0,31},        {31,63,31},        {31,63,0},
        {31,63,63},        {31,0,0},        {31,0,63},        {31,31,0},
        {31,31,63},        {47,47,47},        {15,15,15}
};
*/

   GP_LOGPALENTRY colours[256];
   unsigned long *GpPalette=(unsigned long *)0x14A00400; // Direccion a la Paleta
   
/*
for (n=0;n<=255; n++) {
	 SetColor(n, Paleta[n][0]*4, Paleta[n][1]*4, Paleta[n][2]*4);
}
*/   
   int n, m;
   
   //GP TEMPORAL
   //CPC.scr_bpp = 8;
   //CPC.scr_intensity =10;
   //normal: 0x3AA3
	//CPC.scr_tube = 1;

	//carga la paleta en la GP
	
	//gp_paleta();
	
   switch(CPC.scr_bpp)
   {
      case 8:
         if (!CPC.scr_tube) {
            int n;
            for (n = 0; n < 32; n++) {
               cpc_dword red = (cpc_dword)(colours_rgb[n][0] * (CPC.scr_intensity / 10.0) * 255);
               if (red > 255) { // limit to the maximum
                  red = 255;
               }
               cpc_dword green = (cpc_dword)(colours_rgb[n][1] * (CPC.scr_intensity / 10.0) * 255);
               if (green > 255) {
                  green = 255;
               }
               cpc_dword blue = (cpc_dword)(colours_rgb[n][2] * (CPC.scr_intensity / 10.0) * 255);
               if (blue > 255) {
                  blue = 255;
               }
               colour_table[n] = blue | (green << 8) | (red << 16);
			   //colour_table[n] = ((red>>3)<<11)+((green>>3)<<6)+((blue>>3)<<1);
			   //PARA LA GP
			   //GpPalette[n] = ((red>>3)<<11)+((green>>3)<<6)+((blue>>3)<<1);
			   //GpPalette[n] = ((green>>3)<<11)|((blue>>3)<<6)|((red>>3)<<1);
			   //GpPalette[n]=((red/8)<<11)|((green/8)<<6)|((blue/8)<<1);
			   //SetColor(n, red, green, blue);
            }
         } else {
            int n;
            for (n = 0; n < 32; n++) {
               cpc_dword green = (cpc_dword)(colours_green[n] * (CPC.scr_intensity / 10.0) * 255);
               if (green > 255) {
                  green = 255;
               }
               colour_table[n] = green << 8;
			  // GpPalette[n] = ((green>>3)<<6);
            }
         }
         //gm_memcpy(colours, video_surface->format->palette->colors, sizeof(colours)); // get the default palette
         for (n = 16, m = 0; n < (16+32); n++, m++) { // inserta los 32 coloures del CPC
            colours[n].peRed = (colour_table[m] >> 16) & 0xff;
            colours[n].peGreen = (colour_table[m] >> 8) & 0xff;
            colours[n].peBlue = colour_table[m] & 0xff;
            colours[n].peFlags = 0;
            colour_table[m] = n | (n << 8) | (n << 16) | (n << 24); // cambia indices
         }
         //GP PALETE :?
/*         if (!SDL_SetPalette(video_surface, SDL_LOGPAL | SDL_PHYSPAL, colours, 0, 256)) {
            return ERR_VIDEO_PALETTE;
         }
  */
        paleta = GpPaletteCreateEx (256, (GP_LOGPALENTRY *) colours); 
         GpPaletteSelect (paleta);
         GpPaletteRealize();

/*         paleta = GpPaletteCreate (256,(GP_PALETTEENTRY *) DIA_Pal);
        GpPaletteSelect (paleta);
        GpPaletteRealize();
*/
         break;

      default:
         return ERR_VIDEO_COLOUR_DEPTH;
   }

   for (n = 0; n < 17; n++) { // loop for all colours + border
      GateArray.palette[n] = colour_table[GateArray.ink_values[n]];
   }
   
   //PRINT
	//	GpPalette[255] = 0xFFFE;
	//	GpPalette[254] = 0x7BDE;
	
	
	for(n=240,m=0;n<256;n++,m++)
		GpPalette[n] = teclado_Pal[m];
		
   
   return 0;
}



void video_set_style (void)
{
    //GP TEMPORAL
    //CPC.scr_bpp = 8;

   switch(CPC.scr_bpp)
   {
      case 8:
         switch (CPC.scr_style)
         {
            case 3: // half size
               mode_handler[0] = draw8bpp_mode0_half;
               mode_handler[1] = draw8bpp_mode1_half;
               mode_handler[2] = draw8bpp_mode2_half;
               mode_handler[3] = draw8bpp_mode0_half;
               border_handler = draw8bpp_border_half;
               dwXScale = 1;
               dwYScale = 1;
               break;
         }
   }
   
   //96
   CPC.scr_line_offs = CPC.scr_bps * dwYScale;

   GateArray.scr_mode =
   GateArray.requested_scr_mode = (void(*)(cpc_dword))mode_handler[GateArray.ROM_config & 3];
   GateArray.scr_border = (void(*)(void))border_handler;
}


int video_init (void)
{
    GpGraphicModeSet(GPC_DFLAG_8BPP, NULL);

//	video_surface=NULL;
   CPC.scr_bpp = 8;


   int iErrCode = video_set_palette(); // init CPC colours and hardware palette (in 8bpp mode)
   if (iErrCode) {
      return iErrCode;
   }

   //?? AVERIGUAR Q CONYO ES ESTO XD | bytes por pixel del total de la superficie
   //CPC.scr_bps = CPC_SCR_WIDTH / 4; // rendered screen line length (changing bytes to cpc_dwords)
   CPC.scr_bps = 240 / 4; // rendered screen line length (changing bytes to cpc_dwords)
   
  //CPC.scr_base = (cpc_byte *)0x0c7b4000; // memory address of back buffer
  //CPC.scr_base = (dword *)back_surface->pixels;;
   CPC.scr_base2 = (cpc_byte *)PictureAlt+(GPC_LCD_HEIGHT);

   video_set_style(); // select rendering style
   vdu_init(true); // initialize the monitor emulation

   return 0;
}



void video_shutdown (void)
{
//NO HACER NADA XD
}


//como el << da 15/16fps
/*
void vuelca_optimizado_super_tabla_R(void){
 int x=0,y=0;
 unsigned char *pix = (unsigned char*)&buffer_grafico[RENGLON_INICIAL];;
 unsigned char * LCD=NULL;

	for(y=0;y<back_rect.h;y++) {
		LCD = (unsigned char *)0x0c7b4000+tabla_resta[y];
		for(x=0;x<back_rect.w;x++,pix++,LCD+=240)
			*LCD=*pix;
		pix+=RENGLON;
	}
}
*/

void video_display (int vsync)
{
//volatile long *lcdcon1 = (long *)0x14a00000;
//if(vsync) while(1!=(((*lcdcon1)>>18)&0x1ff));
	//	vuelca_optimizado_super_tabla_R(); //se supone q es la mejor pero esta mas cerca de 14 q de 15

	
/* MUESTRA PAGINA DE VIDEO */
//void FlipScreen(int vsync) {
volatile long *lcdcon1 = (long *)0x14a00000, *lcdaddr1 = (long *)0x14a00014, *lcdaddr2 = (long *)0x14a00018;
if(vsync) while(1!=(((*lcdcon1)>>18)&0x1ff));

if(!gpDrawSurfaceIndex) { *lcdaddr1 += 240*320/2; *lcdaddr2 += 320*240/2; } else { *lcdaddr1 -= 240*320/2; *lcdaddr2 -= 320*240/2; }

Picture = (unsigned char *)(0x0C7B4000+(320*240*gpDrawSurfaceIndex));
gpDrawSurfaceIndex ^= 1;
PictureAlt = (unsigned char *)(0x0C7B4000+(320*240*gpDrawSurfaceIndex));



}
//USAR ESTATICA

void loadConfiguration (void)
{
	  int iRomNum;
	  char cadena[25]="\0";

	  //MODO DE COMIENZO DE LA GP :-
	  CPC.control = 0;
	  CPC.emu_border=1;
	  CPC.frameskip = 1; 
	  
	  
	  
      CPC.model = 2;

      CPC.ram_size = 128; // minimum RAM size for CPC 6128 is 128KB
      CPC.jumpers = 30; //JUMPERS DEL INICIO DE VIDEO

      CPC.speed = DEF_SPEED_SETTING;

   CPC.limit_speed = 0;

   CPC.auto_pause = 1;

   CPC.printer = 0;
   CPC.mf2 = 0; //getConfigValueInt(chFileName, "system", "mf2", 0) & 1;
   CPC.joysticks = 1;// getConfigValueInt(chFileName, "system", "joysticks", 1) & 1;

   CPC.scr_fs_width = 320; //getConfigValueInt(chFileName, "video", "scr_width", 800);
   CPC.scr_fs_height = 240; //getConfigValueInt(chFileName, "video", "scr_height", 600);
   CPC.scr_fs_bpp = 8;//getConfigValueInt(chFileName, "video", "scr_bpp", 8);

   CPC.scr_style = 3;

   CPC.scr_vsync = 0; // = getConfigValueInt(chFileName, "video", "scr_vsync", 1) & 1;
   CPC.scr_led = 1; //getConfigValueInt(chFileName, "video", "scr_led", 1) & 1;
   CPC.scr_fps = 1; //getConfigValueInt(chFileName, "video", "scr_fps", 0) & 1;
   CPC.scr_tube = configuracion.scr_tube; //0 COLOR / 1 VERDE

   CPC.scr_intensity = configuracion.scr_intensity;

   CPC.scr_window = 0; //getConfigValueInt(chFileName, "video", "scr_window", 0) & 1;

   CPC.snd_enabled = configuracion.sonido_ant; //getConfigValueInt(chFileName, "sound", "enabled", 1) & 1;
   sonido_ant=CPC.snd_enabled;

   CPC.snd_playback_rate = 1; //22Khz

   CPC.snd_bits = 0; //getConfigValueInt(chFileName, "sound", "bits", 1) & 1;
   CPC.snd_stereo = 0; //getConfigValueInt(chFileName, "sound", "stereo", 1) & 1;

   CPC.snd_volume = 80;

   CPC.snd_pp_device = 1; //getConfigValueInt(chFileName, "sound", "pp_device", 0) & 1;


   CPC.kbd_layout = 0;

   
   CPC.max_tracksize = 5990; //getConfigValueInt(chFileName, "file", "max_track_size", 6144-154);
   
   for ( iRomNum = 2; iRomNum < 16; iRomNum++){ // loop for ROMs 2-15
		gm_strcpy((char*) CPC.rom_file[iRomNum], (char*)cadena);
	}
   
   gm_strcpy((char*) CPC.rom_mf2, (char*)cadena);
   
   gm_strcpy((char*) CPC.rom_file[7], (char*)"amsdos.rom\0");
   
	
}

void doCleanUpEXIT (void)
{
   printer_stop();
   emulator_shutdown();

   dsk_eject(&driveA);
   dsk_eject(&driveB);
   tape_eject();
/*   if (zip_info.pchFileNames) {
      free(zip_info.pchFileNames);
   }
*/
   audio_shutdown();
   video_shutdown();

   #ifdef DEBUG
   GpFileClose((F_HANDLE)pfoDebug);
   //GpFATUpdate("GP://");
   #endif

//   SDL_Quit();

    GpAppExit();
}


bool load_rom (char *file_name){
   int iErrorCode = 0;


   bool have_DSK = false;
   bool have_SNA = false;
   bool have_TAP = false;
   gm_memset(&driveA, 0, sizeof(t_drive)); // clear disk drive A data structure
   
   char path[50]="gp:\\gpmm\\amstrad\\disks\\";
   
 /*  for ( i = 1; i < argc; i++) { // loop for all command line arguments
      int length = gm_lstrlen(argv[i]);
      if (length > 5) { // minumum for a valid filename
         char path[_MAX_PATH + 1];
         char extension[5];
         if (argv[i][0] == '"') { // argument passed with quotes?
            length -= 2;
            gm_strncpy(path, &argv[i][1], length); // strip the quotes
         } else {
            gm_strncpy(path, &argv[i][0], sizeof(path)-1); // take it as is
         }
         int pos = length - 4;
         if (pos > 0) {
*/
         //char path[_MAX_PATH + 1]="gp:\\gpmm\\abadia.dsk";
         //char extension[5];
			gm_strcat(path, file_name);
            //char file_name[_MAX_PATH + 1];
            
//            bool zip = false;
//GP32
//	void (*lowercase)(char *ptr, int count);
//	int (*compare)(const char *pt1, const char *pt2); 
			//path=;
			//gm_strncpy(path, "gp:\\gpmm\\abadia.dsk", sizeof(path)-1);

			//gm_strcpy(GPDebug,path);
			//gm_sprintf(chStr,"X: %s Insert Disk [%s] ",gm_lstrlen);
            gm_strncpy(extension, (char*)&file_name[(gm_lstrlen(file_name)-4)], 4); // grab the extension
			
            extension[4] = '\0'; // zero terminate string
            
			//gm_lowercase(extension,4);
			//AKI
						
  		if ((!have_DSK) && (gm_memcmp(extension, ".DSK", 4)==0) ){//&& (gm_compare(extension, ".dsk") == 0)) { // a disk image?
                  //gm_strcat(path, file_name);
                  if(!(iErrorCode = dsk_load(path, &driveA, 'A'))) {
                     gm_strcpy(CPC.drvA_path, path);
                     gm_strcpy(CPC.drvA_file, file_name);
//                     CPC.drvA_zip = 0;
                     have_DSK = true;
					 // gm_strcpy(GPDebug,"LEIDO");
					  return 1;
					  
                  }else{
					  //gm_strcpy(GPDebug,"No LEIDO");
						//gm_sprintf(GPDebug,"No LEIDO %i",iErrorCode);
				  }
           
         }
		 
		 
        if ((!have_SNA) && (gm_memcmp(extension, ".SNA", 4)==0)) {
            //strcat(path, file_name);
            if(!snapshot_load(path)) {
                gm_strcpy(CPC.snap_path, path);
                gm_strcpy(CPC.snap_file, file_name);
                //CPC.snap_zip = 0;
                have_SNA = true;
				return 1;
				//result_state=2;
            }//else
				//result_state=0;
				
			//load_state=0;
			//pinta_menu = 1;
			
		}
		 
//ESTA ZONA ES IGNORADA

   if ((!have_DSK) && (CPC.drvA_file[0])) { // insert disk in drive A?
      char chFileName[_MAX_PATH + 1];
     // char *pchPtr;

         gm_strncpy(chFileName, CPC.drvA_path, sizeof(chFileName)-1);
         gm_strncat(chFileName, CPC.drvA_file, sizeof(chFileName)-1 - gm_lstrlen(chFileName));
         dsk_load(chFileName, &driveA, 'A');
   }
   gm_memset(&driveB, 0, sizeof(t_drive)); // clear disk drive B data structure
   if (CPC.drvB_file[0]) { // insert disk in drive B?
      char chFileName[_MAX_PATH + 1];
     // char *pchPtr;


         gm_strncpy(chFileName, CPC.drvB_path, sizeof(chFileName)-1);
         gm_strncat(chFileName, CPC.drvB_file, sizeof(chFileName)-1 - gm_lstrlen(chFileName));
         dsk_load(chFileName, &driveB, 'B');
 
   }
   if ((!have_TAP) && (CPC.tape_file[0])) { // insert a tape?
      char chFileName[_MAX_PATH + 1];
     // char *pchPtr;

         gm_strncpy(chFileName, CPC.tape_path, sizeof(chFileName)-1);
         gm_strncat(chFileName, CPC.tape_file, sizeof(chFileName)-1 - gm_lstrlen(chFileName));

      if (!iErrorCode) {
         int iOffset = gm_lstrlen(CPC.tape_file) - 3;
         char *pchExt = &CPC.tape_file[iOffset > 0 ? iOffset : 0]; // pointer to the extension
		 //GP32 poner pchExt a lowercase por si acaso :D
		 
         if (gm_compare(pchExt, "cdt") == 0) { // is it a cdt file?
            iErrorCode = tape_insert(chFileName);
         }
         else if (gm_compare(pchExt, "voc") == 0) { // is it a voc file?
            iErrorCode = tape_insert_voc(chFileName);
         }
      }
   }
return 0;

}

void cpc_main (void)
{
	GpFatInit();
		

	process_loadcfg();
	
volatile long *lcdcon1 = (long *)0x14a00000;
 //  cpc_dword dwSndDist;
   bool bolDone;
	int spool_ticks=0;
	
   //char chStr[40];
   //int i;
   //int iErrorCode = 0;
   
    
	//gm_strncpy(botones_usr, configuracion.botones_usr, 10);
	

   
   loadConfiguration(); // retrieve the emulator configuration

   z80_init_tables(); // init Z80 emulation
   video_init_tables(); // generate the byte-to-pixels translation tables

   // init input
   if (video_init()) {
      doCleanUpEXIT();
   }
  

   if (audio_init()) {
      CPC.snd_enabled = 0; // disable sound emulation
   }

    //SIN SONIDO
   CPC.snd_enabled = 0;

   if (emulator_init()) {
      doCleanUpEXIT();
   }

   
   
   #ifdef DEBUG
   
   char GPfichero[50]="Abierto\0";
   char pfoNombre[50]="gp:\\gpmm\\debug.txt";
   
   if (GpFileCreate (pfoNombre, ALWAYS_CREATE, &pfoDebug) != SM_OK){
   			GPfichero[0]='\0';
	}	   
   #endif
	   

	//   load_rom ((char*)"gp:\\gpmm\\abadia.dsk");
	   
// ----------------------------------------------------------------------------

   dwTicksOffset = (int)(20.0 / (double)((CPC.speed * 25) / 100.0));
   
   //dwTicksTarget = GpTickCountGet();

   dwTicksTargetFPS = dwTicksTarget;
   dwTicksTarget += dwTicksOffset;

   audio_resume();

   int iExitCondition = EC_FRAME_COMPLETE;
   bolDone = false;   
   
   CPC.paused = 1; //comienza en pausa para el menu :-d
   pal_menu(); //pone los colores para el menu :D
   
   GPframeskip=CPC.frameskip+1; //0 seria nunca :D
   //sino no se ve xDs
   //CPC.frameskip^= 1;
  // int snd=0;
  
  
 
   while (!bolDone) {
		
	   poll_input();
	   //kbd_buf_update(); 
	   
		//	gm_sprintf(chStr,"S: %i Ticks: %i", spool, spool_ticks); //para hacer el spool de comandos...
		//	print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*3)+230), (char*)chStr, false); // SPOOL
	   
      if (!CPC.paused) { // run the emulation, as long as the user doesn't pause it
/*
	  if ((CPC.limit_speed) && (iExitCondition == EC_CYCLE_COUNT)) {
            int iTicksAdj = 0; // no adjustment necessary by default
            dwTicks = GpTickCountGet();
			
         if (CPC.snd_enabled) {
               if (pbSndStream < CPC.snd_bufferptr) {
                  dwSndDist = CPC.snd_bufferptr - pbSndStream; // determine distance between play and write cursors
               } else {
                  dwSndDist = (pbSndBufferEnd - pbSndStream) + (CPC.snd_bufferptr - pbSndBuffer);
               }
               if (dwSndDist < dwSndMinSafeDist) {
                  iTicksAdj = -5; // speed emulation up to compensate
               } else if (dwSndDist > dwSndMaxSafeDist) {
                  iTicksAdj = 5; // slow emulation down to compensate
               }
			}
			
            if (dwTicks < (dwTicksTarget+iTicksAdj)) { // limit speed?
               continue; // delay emulation
            }
            dwTicksTarget = dwTicks + dwTicksOffset; // prep counter for the next run
         }
*/		 
/*
         if (iExitCondition == EC_FRAME_COMPLETE) { // did the last call blit the video buffer?
				//CPC.scr_base = (cpc_dword *)&buffer_grafico[0];
				//CPC.scr_base = (cpc_dword *)0x0c7b4000;//+(CPC.scr_line_offs-1);//+240;
				CPC.scr_base2 = (cpc_byte *)PictureAlt+(GPC_LCD_HEIGHT);//+240;
         }
*/

			
         iExitCondition = z80_execute(); // run the emulation until an exit condition is met
		 
				
         if (iExitCondition == EC_FRAME_COMPLETE) { // emulation finished rendering a complete frame?

		 
			if(spool){
				
				if(!spool_ticks){
					spool_ticks=GpTickCountGet();
					
				}
				else if((GpTickCountGet()-spool_ticks)>2000){
					spool=0;
					spool_ticks=0;
					//CPC.emu_border=1;
					//spool_act=0;
				}
				 
				 if(reiniciado){
					 if((GpTickCountGet()-spool_ticks)>1000){
						 if(reiniciado++>3){
							  spool_ticks=0;
							  reiniciado=0;
						 }else
							  spool_ticks=0;
					 }
				 }else if(spoolkeys.cont||spoolkeys.comienzo){
						process_spoolkey(spool_ticks);
				 }
					
				print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*3)+230), (char*)spool_cad, false); // SPOOL
			}
			
			
				if(FDC.led)
					pinta_led((cpc_byte *)Picture);

				if(CPC.control%2)
					pinta_teclado((cpc_byte *)Picture);



			CPC.scr_base2 = (cpc_byte *)Picture+(GPC_LCD_HEIGHT);

			//GPframe
			CPC.frameskip^= 1;
			
         }
		 
       }else{
	   
	   if(pinta_menu)
		   menu ();
	   
	   if(GPChangeDISK){
		   load_rom (rom_name);
		   GPChangeDISK=0;
		    if((gm_lstrlen(rom_name))>4){
				gm_strncpy(file_state, (char*)&rom_name[0], (gm_lstrlen(rom_name)-4)); // grab the extension
				gm_strcat(file_state, ".SNA");
			}else{
				gm_strcpy(file_state, (char*)"none");
			}
			
		}
		
		
		if(save_state){
			snapshot_save (file_state); //lo del path es temporal... xD
			GpFATUpdate("GP://");
			save_state=0;
			result_state=1; 
			pinta_menu = 1;
		}

		
	if(load_state){
		//gm_sprintf(state,"STATE000.PTK");
		     if(!snapshot_load(file_state)) {
                //gm_strcpy(CPC.snap_path, "gp:\\gpmm\\amstrad");
                //gm_strcpy(CPC.snap_file, state);
                //CPC.snap_zip = 0;
                //have_SNA = true;
				result_state=2; 
            }else{
			result_state=0;
			}
		load_state=0;
		pinta_menu = 1;
		//snapshot_load (path); //lo del path es temporal... xD
	}

		   
			//char chStr[40];(cpc_byte *)
/*			gm_sprintf(chStr,"PAUSED"); //30 parece la mita :?
			print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*130)+120), (char*)chStr, true); // LETRITAS :D

			gm_sprintf(chStr,"(A = REBOOT .::. START = RETURN)"); //30 parece la mita :?
			print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*30)+13), (char*)chStr, true); // LETRITAS :D

			if(!CPC.control) gm_sprintf(chStr,"PituKa v0.7M - PAD MODE: JOYSTICK ");
			else	gm_sprintf(chStr,"PituKa v0.7M - PAD MODE: CFG USER ");
			print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*10)+230), (char*)chStr, true); // LETRITAS :D
			*/
			while(1!=(((*lcdcon1)>>18)&0x1ff));
			//video_display(0);
	   }
	  
	  
	  
   }
   
   doCleanUpEXIT();


}


void GpMain(void *arg)
{
	int fclk=3;
	int speed=132000000;//156000000;//166000000
	
			//GpClockSpeedChange(132000000, 0x3a011, 3); //133Mhz
	/*0x2c001*/ //156Mhz
	GpClockSpeedChange(speed, 0x3a011 , fclk); 
	//GpClockSpeedChange(166000000, 0x4b011, 3);  //166Mhz

	
    logo(1); //IMG de buscando chatboard

	gp_setCpuspeed(133);//156);//166);//
	chatboard=gp_initChatboard();


		  logo(0); //presentacion


			while(GpKeyGet()!=0x40);//GPC_VK_A
			while(GpKeyGet()==0x40);//GPC_VK_A
	

	
    cpc_main();
	

	
}
