// thanx to Jouni Korhonen for this file

struct threeMap {
        unsigned char key;
        const char *map1;
        const char *map2;
};


struct threeMap cha01KeyMap[] = {
        {'1',   "1\",20\r",                             "0c1111111111111111\"\r"},
        {'2',   "2\",20\r",                             "1c222222222\"\r"},
        {'3',   "3\",20\r",                             "1c333333\"\r"},
        {'4',   "4\",20\r",                             "1c44444\"\r"},
        {'5',   "5\",20\r",                             "1c5555\"\r"},
        {'6',   "6\",20\r",                             "1c66666666\"\r"},
        {'7',   "7\",20\r",                             "1c777777\"\r"},
        {'8',   "8\",20\r",                             "1c888888\"\r"},
        {'9',   "9\",20\r",                             "1c99999\"\r"},
        {'0',   "0\",20\r",                             "1c0000000000000\"\r"},
        {'\r',  "eee\"\r",                              "c\"\r"},            // BACKSPACE!
        {'!',   "1111\"\r",                             "0c1111\"\r"},
        {'@',   "000\"\r",                              "1c000\"\r"},
        {'#',   "#\"\r",                                "1c#\"\r"},
        {'$',   "0000000\"\r",                          "1c0000000\"\r"},
        {'%',   "000000\"\r",                           "1c000000\"\r"},
        {'?',   "111\"\r",                              "0c111\"\r"},
        {'&',   "00\"\r",                               "1c00\"\r"},
        {'*',   "##\"\r",                               "1c##\"\r"},
        {'(',   "11111111111111\"\r",                   "0c11111111111111\"\r"},
        {')',   "111111111111111\"\r",                  "0c111111111111111\"\r"},
        {'q',   "77\"\r",                               "1c77\"\r"},
        {'w',   "9\"\r",                                "1c9\"\r"},
        {'e',   "33\"\r",                               "1c33\"\r"},
        {'r',   "777\"\r",                              "1c777\"\r"},
        {'t',   "8\"\r",                                "1c8\"\r"},
        {'y',   "999\"\r",                              "1c999\"\r"},
        {'u',   "88\"\r",                               "1c88\"\r"},
        {'i',   "444\"\r",                              "1c444\"\r"},
        {'o',   "666\"\r",                              "1c666\"\r"},
        {'p',   "7\"\r",                                "1c7\"\r"},
        {'a',   "2\"\r",                                "1c2\"\r"},
        {'s',   "7777\"\r",                             "1c7777\"\r"},
        {'d',   "3\"\r",                                "1c3\"\r"},
        {'f',   "333\"\r",                              "1c333\"\r"},
        {'g',   "4\"\r",                                "1c4\"\r"},
        {'h',   "44\"\r",                               "1c44\"\r"},
        {'j',   "5\"\r",                                "1c5\"\r"},
        {'k',   "55\"\r",                               "1c55\"\r"},
        {'l',   "555\"\r",                              "1c555\"\r"},
        {'z',   "9999\"\r",                             "1c9999\"\r"},
        {'x',   "99\"\r",                               "1c99\"\r"},
        {'c',   "222\"\r",                              "1c222\"\r"},
        {'v',   "888\"\r",                              "1c888\"\r"},
        {'b',   "22\"\r",                               "1c22\"\r"},
        {'n',   "66\"\r",                               "1c66\"\r"},
        {'m',   "6\"\r",                                "1c6\"\r"},
        {'.',   "111111\"\r",                           "0c111111\"\r"},
        {'<',   "<\"\r",                                "<\"\r"}, 
        {'>',   ">\"\r",                                ">\"\r"},
        {' ',   "1\"\r",                                "0c1\"\r"},
        {'?',   "2222222\"\r",                          "1c2222222\"\r"},
        {'?',   "22222222\"\r",                         "1c22222222\"\r"},
        {'',   "3333\"\r",                             "1c3333\"\r"},
        {'',   "33333\"\r",                            "1c3333\"\r"},
        {'?',   "4444\"\r",                             "1c4444\"\r"},
        {':',   "1111111\"\r",                          "0c1111111\"\r"},
        {'?',   "6666\"\r",                             "1c6666\"\r"},
        {'?',   "6666666\"\r",                          "1c6666666\"\r"},
        {'',   "77777\"\r",                            "1c77777\"\r"},
        {'',   "8888\"\r",                             "1c8888\"\r"},
        {'?',   "88888\"\r",                            "1c88888\"\r"},
        {'',   "2222\"\r",                             "1c2222\"\r"},
        {'\'',  "1111111111\"\r",                       "0c1111111111\"\r"},
        {'?',   "222222\"\r",                           "1c222222\"\r"},
        {'"',   "111111111\"\r",                        "0c111111111\"\r"},
        {'',   "666666\"\r",                           "1c666666\"\r"},
        {'',   "00000000\"\r",                         "1c00000000\"\r"},
        {'',   "66666\"\r",                            "1c66666\"\r"},
        {'',   "22222\"\r",                            "1c22222\"\r"},
        {'+',   "0\"\r",                                "1c0\"\r"},
        {'-',   "11\"\r",                               "0c11\"\r"},
        {'',   "00000000000000000\"\r",                "1c00000000000000000\"\r"},
        {'?',   "0000000000000000\"\r",                 "1c0000000000000000\"\r"},
        {'/',   "0000\"\r",                             "1c0000\"\r"},
        {'',   "7777777\"\r",                          "1c7777777\"\r"},
        {'?',   "77777777\"\r",                         "1c77777777\"\r"},
        {'?',   "11111\"\r",                            "0c11111\"\r"},
        { 0  ,0  ,0 }
};

