/* PituKa - Amstrad CPC Emulator
   (c) Copyright 2004-2005 David Skywalker

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/


#include "../cap32.h"
#include "../rlyeh/snaps/snapshot.h"
#include "files/explorer.h"

//LIBS
#include <gpgraphic.h>
#include <gpstdlib.h>
#include <gpfont.h>
#include <stdlib.h>


//DEFINES


#define RGB2INT(R,G,B) ((R/8)<<11)|((G/8)<<6)|((B/8)<<1)

#define INT2R(I) ((I>>11)*8)
#define INT2G(I) ((I>>6)*8)
#define INT2B(I) ((I>>1)*8)

#define MENU_DISK 5
#define MENU_SNAP 4
#define MENU_OPTIONS 3
#define MENU_RESTART 2
#define MENU_EXIT 1

#define OPCION_TUBE 4
#define OPCION_SND 3
#define OPCION_GAMMA 2
#define OPCION_BACK 1

#define SNAP_LOAD 3
#define SNAP_SAVE 2
#define SNAP_BACK 1

#define DISK_LOAD 3
#define DISK_SAVE 2
#define DISK_BACK 1

extern cpc_byte keyboard_matrix[16];
extern cpc_byte keyboard_translation[320];
extern cpc_byte bit_values[8];
extern t_CPC CPC;
extern t_VDU VDU;
extern GP_Rect back_rect;
extern GP_cursor puntero;
extern GP_cursor seleccion;
extern GP_cursor cfg_tecla;
extern bool pinta_menu;
extern GP_HPALETTE paleta;
extern unsigned char * pbSndBuffer;
extern unsigned char submenu;

extern char spool_cad[20];
extern bool spool;
extern bool spool_act;
unsigned char num_snap;
bool sonido_ant;

extern char rom_name[16];
//extern  FOLDER folder;
extern bool GPChangeDISK;

extern GPSOUNDBUF sonido;

extern PituKa_CFG configuracion; 

extern bool save_state;
extern bool load_state;
extern unsigned char result_state;
unsigned char incrementos=15;
unsigned char tope=5;

extern GP_PALETTEENTRY teclado_Pal[16];
extern GP_PALETTEENTRY menu_Pal[32];

extern Pituka_SpoolKeys spoolkeys;

#define MODO_JOYSTICK 0
#define MODO_TECLADO 1
#define MODO_USUARIO 2

unsigned char tabla_teclado[90]={									//0		-		^		CLR	DEL	F7	F8 	F9
0x82,0x82,0x80,0x81,0x71,0x70,0x61,0x60,0x51,0x50,0x41,0x40,0x31,0x30,0x97,0x12,0x13,0x03,
0x84,0x84,0x83,0x73,0x72,0x62,0x63,0x53,0x52,0x43,0x42,0x33,0x32,0x21,0x22,0x24,0x14,0x04,
0x86,0x86,0x85,0x74,0x75,0x65,0x64,0x54,0x55,0x45,0x44,0x35,0x34,0x23,0x22,0x15,0x16,0x05,
0x25,0x25,0x87,0x77,0x76,0x67,0x66,0x56,0x46,0x47,0x37,0x36,0x26,0x25,0x25,0x17,0x00,0x07,
0x27,0x27,0x11,0x11,0x57,0x57,0x57,0x57,0x57,0x57,0x57,0x57,0x06,0x06,0x06,0x10,0x02,0x01
};

const unsigned char botones_def[10]={
0x90, //UP
0x93,//RIGHT
0x91,//DW
0x92,//LEFT
0x94,//B
0x95,//A
0xFF,//SELECT
0xFF,//START
0xFF,//RL
0xFF,//RR
};

const unsigned char botones_usr_DEFECTO[10]={
0x00, //UP
0x01,//LEFT
0x02,//DW
0x10,//RIGHT
0x85,//A
0x57,//B
0x54,//SELECT
0xFF,//START
0xFF,
0xFF,
};


unsigned char * botones_usr;

//CHATBOARD
void pituka_chatboard(void);
extern int chatboard;
int chatboardSymb=0, chatboardShift=0, chatboardExt=0;

void save_cfgkey(char * filename);
void load_cfgkey(char * filename);

void process_snap(void){
 //unsigned char * LCD = (unsigned char *)0x0c7b4000;
 //unsigned char DST[320*240+240]; //(unsigned char *)gm_malloc(320*240+240);
 
  unsigned char *dst=NULL; long size=0;
      F_HANDLE fp;
 int n;

 unsigned long *GpPalette=(unsigned long *)0x14A00400;
 // F_HANDLE f2;
  
     unsigned char *buf, *bufp;
	 
     //char mPal=mGBPal;
	char path[50];

	gm_sprintf(path,"gp:\\gpmm\\amstrad\\screens\\cpcimg%i.bmp",(int)num_snap++);
	
     GpSoundBufStop();
	 

     buf=bufp=gm_malloc(320*240);

     if(buf==NULL) while(1) { /*NO HAY MEMORIA*/ }

     { unsigned char *x=(unsigned char *)0x0c7b4000; int i; for(i=0;i<320*240;i++,x++) (*bufp++)=*(x+320*240)=*x; }


 unsigned char pal[768];
 
 for(n=0;n<256;n++, GpPalette++){ pal[n*3] = INT2R(*GpPalette); pal[n*3+1] = INT2G(*GpPalette); pal[n*3+2] = INT2B(*GpPalette);  }
 /*=
{
   127, 127, 127, 127, 127, 127 , 0, 255, 127 ,  255, 255, 127 ,
   0, 0, 127 , 255, 0, 127 , 0, 127, 127 , 255, 127, 127 ,
   255, 0, 127 , 255, 255, 127 , 255, 255, 0 , 255, 255, 255 ,
   255, 0, 0 , 255, 0, 255 , 255, 127, 0 , 255, 127, 255 ,
   0, 0, 127 , 0, 255, 127 , 0, 255, 0 , 0, 255, 255 ,
   0, 0, 0 , 0, 0, 255 , 0, 127, 0 , 0, 127, 255 ,
   127, 0, 127 , 127, 255, 127 , 127, 255, 0 , 127, 255, 255 ,
   127, 0, 0 , 127, 0, 255 , 127, 127, 0 , 127, 127, 255 
};
*/

       if(buf!=NULL) dst=gm_zi_malloc(320*240+2048);

      if(dst!=NULL)
      {
       size=SaveBMP(buf,dst,pal);//0;//SavePNG8(buf,dst,pal);
	   
	   
	  if(GpFileCreate(path,ALWAYS_CREATE,&fp)==SM_OK)
       {
        GpFileClose(fp);

        if(GpFileOpen(path,OPEN_W,&fp)==SM_OK)
        {
         GpFileWrite(fp,(void *)&dst[0],size); 
         GpFileClose(fp);
		 spool=1;
		 
		gm_sprintf(spool_cad,"Process Snapshot: %d Kbytes",size/1024);
		}
	   
    //   GpFileCreate(, ALWAYS_CREATE, &f2);
        //GpFileWrite(f2, &MyBmp.Header, 54);
//		GpFileWrite(f2, (unsigned char*) DST, sizeof(DST));
  //    GpFileClose(f2);
	   
	   }
	   gm_free(dst);
		
	   }
	  
gm_free(buf);


//GpFatInit();
//writebmp(,LCD);


GpFATUpdate("GP://");
//gm_free(DST);

GpSoundBufStart( &sonido );

}

void pal_menu (void){
		int n,m;
		 unsigned long *GpPalette=(unsigned long *)0x14A00400; // Direccion a la Paleta
 
		 //Prepara paleta
	    paleta = GpPaletteCreate (32,(GP_PALETTEENTRY *) menu_Pal);
        GpPaletteSelect (paleta);
        GpPaletteRealize();
		//Paleta para fuentes		
		for(n=240,m=0;n<256;n++,m++)
			GpPalette[n] = teclado_Pal[m];


}

void process_menu (void){

	if(!CPC.paused){
	  if (video_init()) {
		  doCleanUpEXIT();
	   }
	  CPC.snd_enabled=sonido_ant;
	  
	}else{
		//limpia sonido
		sonido_ant=CPC.snd_enabled;
		CPC.snd_enabled=0;
		gm_memset(pbSndBuffer, 0, CPC.snd_buffersize*2);
		//prepara paleta menu
		pal_menu();
		//pinta menu 1 vez
		pinta_menu=1;
		
	}
		

}

	cpc_byte cpc_key=0, cpc_key_push=0xff;

void process_input(bool pressed, unsigned char value) {
int temporal=2;
  if(!CPC.paused){

	switch(CPC.control){
		
		case MODO_TECLADO:

			if(value==LEFT_PRESSED) {
								if(pressed){
									if(puntero.x>0){
										puntero.px-=10;
										puntero.x-=1;
									}else{
										puntero.px=180;
										puntero.x=17;							
									}
								}
			}

			if(value==RIGHT_PRESSED){
								if(pressed){
									if(puntero.x<17){
										puntero.px+=10;
										puntero.x+=1;
									}else{
										puntero.px=20;
										puntero.x=1;
									}
								}
			}
				//CAMBIO FACIL PARA LA PANTALLA GIRADA :)
			if(value==UP_PRESSED){
								if(pressed){
									if(puntero.y>0){
										puntero.py+=10;
										puntero.y-=1;
									}else{
										puntero.py=12;
										puntero.y=4;
									}
								}
			}
					
			if(value==DOWN_PRESSED){
								if(pressed){
									if(puntero.y<4){
										puntero.py-=10;
										puntero.y+=1;
									}else{
										puntero.py=52;
										puntero.y=0;
									}
								}
			}
								
			if(value==A_PRESSED){
				if(!pressed){
					cpc_key = cpc_key_push;
					if ((cpc_key != 0xff))
						 keyboard_matrix[cpc_key >> 4] |= bit_values[cpc_key & 7];  // tecla soltada
				} else {
					cpc_key = tabla_teclado[((puntero.y*18)+puntero.x)];
					if ((cpc_key != 0xff)){
						 keyboard_matrix[cpc_key >> 4] &= ~bit_values[cpc_key & 7]; // tecla pulsada
						 cpc_key_push=cpc_key;
					}
				}
			}
			
			if(value==B_PRESSED){
				if(!pressed){
					 spool=1;
					 //gm_sprintf(spool_cad,"X: %i Y: %i",cfg_tecla.px,cfg_tecla.py);
					 botones_usr[cfg_tecla.x]=tabla_teclado[((puntero.y*18)+puntero.x)];
					 gm_sprintf(spool_cad,"You have remapped a key");
				}
			}
			
			if(value==START_PRESSED){
				if(!pressed){
					if(cfg_tecla.x<6)
						cfg_tecla.x+=1;
					else
						cfg_tecla.x=0;
				}
			}

				
			if(value==SELECT_PRESSED){
				if(!pressed){
					cpc_key = 0x06; //INTRO
					if ( (cpc_key != 0xff))
						 keyboard_matrix[cpc_key >> 4] |= bit_values[cpc_key & 7];  // tecla soltada
				} else {
					cpc_key = 0x06;
					if ((cpc_key != 0xff))
						 keyboard_matrix[cpc_key >> 4] &= ~bit_values[cpc_key & 7]; // tecla pulsada
				}
			}

				
			if(value==LSHOULDER_PRESSED){
				if(!pressed){
					cpc_key = 0x25; //SHIFT
					if ((cpc_key != 0xff))
						 keyboard_matrix[cpc_key >> 4] |= bit_values[cpc_key & 7];  // tecla soltada
				} else {
					cpc_key = 0x25;
					if ((cpc_key != 0xff))
						 keyboard_matrix[cpc_key >> 4] &= ~bit_values[cpc_key & 7]; // tecla pulsada
				}
			}

			
		break;
		
		//MODO JOSTICK!!

		case MODO_JOYSTICK:
		
			switch(value){
				case START_PRESSED:
					if(!pressed){
						CPC.paused=(CPC.paused+1)&0x01; //Cambia 0/1
						process_menu();
					}
				case SELECT_PRESSED:
				break;
				case LSHOULDER_PRESSED:
				if(!pressed){
					process_snap();
				}
				break;
				
				case A_PRESSED:
				//	if(CPC.paused)
				//		doCleanUpEXIT();
				
				default:
				if(!pressed){
				cpc_key = botones_def[value]; //C.L
                if ((cpc_key != 0xff))
                     keyboard_matrix[cpc_key >> 4] |= bit_values[cpc_key & 7];  // tecla soltada

				} else {
					cpc_key = botones_def[value]; //C.L
					if ((cpc_key != 0xff))
						 keyboard_matrix[cpc_key >> 4] &= ~bit_values[cpc_key & 7]; // tecla pulsada
				}
			}

		break;
				
		//MODO USUARIO!!

		case MODO_USUARIO:

			switch(value){
				case START_PRESSED:
					if(!pressed){
					CPC.paused^=1; //Cambia 0/1
					process_menu();
					}
				break;
				case A_PRESSED:
			//		if(CPC.paused)
			//			doCleanUpEXIT();
					
				default:
					if(!pressed){
						cpc_key = botones_usr[value]; //C.L
						if ((cpc_key != 0xff))
							 keyboard_matrix[cpc_key >> 4] |= bit_values[cpc_key & 7];  // tecla soltada

						} else {
						cpc_key = botones_usr[value]; //C.L
						if ((cpc_key != 0xff))
							 keyboard_matrix[cpc_key >> 4] &= ~bit_values[cpc_key & 7]; // tecla pulsada
					}
			}
		break;
			
	}
  }else{
  
  //AKI EL MENU
			if(value==UP_PRESSED){
								if(pressed&&seleccion.y<tope){
									seleccion.py+=incrementos;
									seleccion.y+=1;
									pinta_menu=1;
								}
			}
					
			if(value==DOWN_PRESSED){
								if(pressed&&seleccion.y>1){
									seleccion.py-=incrementos;
									seleccion.y-=1;
									pinta_menu=1;
								}
			}
				
			if(value==START_PRESSED){
					if(!pressed && !submenu){
						CPC.paused=(CPC.paused+1)&0x01; //Cambia 0/1
						process_menu();
					}
			}
/*			if(value==SELECT_PRESSED){
					if(!pressed && !submenu){
						//process_savecfg();
					}
			}
*/				

			if(value==B_PRESSED){
				if(!submenu){
					if(!pressed){
						CPC.paused=(CPC.paused+1)&0x01; //Cambia 0/1
						process_menu();
					}
				}else{
						if(!pressed){
							
							if(submenu==1){
								seleccion.y=MENU_OPTIONS;
								seleccion.py=125;
							}else{
								seleccion.y=MENU_SNAP;
								seleccion.py=140;
							}
							result_state=0;
							submenu=0;
							pinta_menu=1;
							incrementos=15;
							tope=5;
						}
				}
			}
			
			
			if(value==A_PRESSED){
				if(!pressed){
					if(!submenu){
					  switch (seleccion.y){
					
						case MENU_DISK:
							 //guarda teclas
							 save_cfgkey(rom_name);
							if((temporal = explora (&rom_name[0])))
								gm_sprintf(rom_name, "ERROR: %i", (int) temporal);
							else{
								GPChangeDISK=1;
								spool=1;
								//gm_sprintf(spool_cad,"Loading, Please Wait...");
								//gm_sprintf(spool_cad,"Please Wait...");
								spool_cad[0]='\0';
								load_cfgkey(rom_name);
							}
								
							//gm_strcat(rom_name, )
							
							pinta_menu=1;
							break;
							
						case MENU_SNAP:
							submenu=2;
							seleccion.py=95;
							seleccion.y=SNAP_BACK;
							incrementos=20;
							pinta_menu=1;
							tope=3;
						break;
					
						case MENU_OPTIONS:
							submenu=1;
							seleccion.py=95;
							seleccion.y=OPCION_BACK;
							incrementos=20;
							pinta_menu=1;
							tope=4;
							break;
						case MENU_RESTART:
							emulator_reset(false); 
							break;
						case MENU_EXIT:			
							process_savecfg();
							
							doCleanUpEXIT();
								
							break;					
					
					  }
					}else 
					if(submenu==1){
					  switch (seleccion.y){
					
						case OPCION_TUBE:
							CPC.scr_tube^=1;
							break;
					
						case OPCION_SND:
							sonido_ant^=1;
							break;
						
						case OPCION_GAMMA:
							CPC.scr_intensity++;
							if(CPC.scr_intensity>14)
								CPC.scr_intensity=5;
							break;
						
						case OPCION_BACK:
							submenu=0;
							seleccion.py=125;
							seleccion.y=MENU_OPTIONS;
							incrementos=15;
							tope=5;
							break;					
					
					  }
					  
						pinta_menu=1;

					}else 
					if(submenu==2){
					
					  switch (seleccion.y){
					
						case SNAP_SAVE:
							save_state=1;
						break;
						
						case SNAP_LOAD:
							load_state=1;
						break;
						
						case SNAP_BACK:
							submenu=0;
							seleccion.py=140;
							seleccion.y=MENU_SNAP;
							incrementos=15;
							tope=5;
							result_state=0;
							break;
						}
						
						pinta_menu=1;
						
					}
				
				
				}
			}
				
	}
} 


void poll_input(void) {
	static cpc_dword last_pbdat=0;
	static cpc_dword last_pedat=0;
	cpc_dword current_pbdat;
	cpc_dword current_pedat;

	if(!last_pbdat) last_pbdat=(*(volatile cpc_dword *)0x1560000c);
	if(!last_pedat) last_pedat=(*(volatile cpc_dword *)0x15600030);

	current_pbdat=(*(volatile cpc_dword *)0x1560000c);
	current_pbdat&=0x0000ff00;
	current_pedat=(*(volatile cpc_dword *)0x15600030);
	current_pedat&=0x000000c0;

//				process_input(0, left_function, left_value);
	if(current_pbdat!=last_pbdat) {
		/* left */
		if((current_pbdat^last_pbdat)&0x00000100) {
			if(current_pbdat&0x00000100) {
//				button_state&=~(cpc_dword)LEFT_PRESSED;
				process_input(0, LEFT_PRESSED);
/*				cpc_key = 0x10; //C.L
                if ((!CPC.paused) && (cpc_key != 0xff))
                     keyboard_matrix[cpc_key >> 4] |= bit_values[cpc_key & 7];  // tecla soltada
*/
			} else {
				process_input(1, LEFT_PRESSED);
//				button_state|=LEFT_PRESSED;
//				process_input(1, left_function, left_value);
/*				cpc_key = 0x10; //C.L
                if ((!CPC.paused) && (cpc_key != 0xff))
                     keyboard_matrix[cpc_key >> 4] &= ~bit_values[cpc_key & 7]; // tecla pulsada
*/
			}
		}
		/* right */
		if((current_pbdat^last_pbdat)&0x00000400) {
			if(current_pbdat&0x00000400) {
				process_input(0, RIGHT_PRESSED);
			} else {
				process_input(1, RIGHT_PRESSED);
			}
		}
		/* up */
		if((current_pbdat^last_pbdat)&0x00000800) {
			if(current_pbdat&0x00000800) {
				process_input(0, UP_PRESSED);
			} else {
				process_input(1, UP_PRESSED);
			}
		}
		/* down */
		if((current_pbdat^last_pbdat)&0x00000200) {
			if(current_pbdat&0x00000200) {
				process_input(0, DOWN_PRESSED);
			} else {
				process_input(1, DOWN_PRESSED);
			}
		}
		/* left shoulder button */
		if((current_pbdat^last_pbdat)&0x00001000) {
			if(current_pbdat&0x00001000) {
				process_input(0, LSHOULDER_PRESSED);
			} else {
				process_input(1, LSHOULDER_PRESSED);
			}
		}
		/* button B */
		if((current_pbdat^last_pbdat)&0x00002000) {
			if(current_pbdat&0x00002000) {
				process_input(0, B_PRESSED);
			} else {
				process_input(1, B_PRESSED);
				}
		}
		/* button A */
		if((current_pbdat^last_pbdat)&0x00004000) {
			if(current_pbdat&0x00004000) {
				process_input(0, A_PRESSED);
			} else {
				process_input(1, A_PRESSED);
				}
		}
		/* right shoulder button */
		if((current_pbdat^last_pbdat)&0x00008000) {
			if(current_pbdat&0x00008000) {
//				button_state&=~(cpc_dword)RSHOULDER_PRESSED;
//				process_input(0, RSHOULDER_PRESSED);
				if ((!CPC.paused)){//&&(!spool_act)) { 
					CPC.control++;
					spool=1;
					//spool_act=1;
					//limpiamos la memoria del teclado para q no se cuelgue :D
					gm_memset(keyboard_matrix, 0xff, sizeof(keyboard_matrix));
					//no emular bordes para evitar parpadeo :-
					//CPC.emu_border=0;
					switch(CPC.control){
						case 0x01:
							VDU.vheight = 176;
							gm_sprintf(spool_cad,"vKeyboard Mode");
						break;
						case 0x02:
							VDU.vheight = CPC_VISIBLE_SCR_HEIGHT;
							gm_sprintf(spool_cad,"UserCFG Mode");
						break;
						default:
							CPC.control=0;
							gm_sprintf(spool_cad,"Joystick Mode");
					}
					
				}
			} else {
				//button_state|=RSHOULDER_PRESSED;
			}
		}
		last_pbdat=current_pbdat;
	}

	if(current_pedat!=last_pedat) {
		/* start */
		if((current_pedat^last_pedat)&0x00000040) {
			if(current_pedat&0x00000040) {
				process_input(0, START_PRESSED);
			} else {
				process_input(1, START_PRESSED);
			}
		} 
		/* select */
		if((current_pedat^last_pedat)&0x00000080) {
			if(current_pedat&0x00000080) {
				process_input(0, SELECT_PRESSED);
			} else {
				process_input(1, SELECT_PRESSED);
			}
		}
		last_pedat=current_pedat;
	}

	//if(chatboard_enabled) gp_getChatboard();
	if(chatboard)	pituka_chatboard();
}

#define PituKey(a) keyboard_matrix[ keyboard_translation[a] >>4] &= ~bit_values[keyboard_translation[a]&7]; // tecla pulsada
#define PituRKey(a) keyboard_matrix[ keyboard_translation[a] >>4] |= bit_values[keyboard_translation[a]&7]; // tecla soltada

unsigned char tecla_pulsada=0;


void pituka_chatboard_test(void){
	 char get=0;
	//char buffer[1024]; 
  
	 get=gp_getChatboard();
     
     if (get&&!spool) { 
		 gm_sprintf(spool_cad,"-%d %c-     ",get,get); spool=1;
	 }

}

void pituka_chatboard(void){
    //bool keypressed=1;
//	static unsigned char tecla_pulsada=0;
	static int ticks=0;
	char get=0;
/*
    if(!chatboardExt){
        if(!(chatboardSymb && chatboardShift)){ //if not in spectrum E mode...
            
             if(chatboardShift){ PituKey(0x25); //SHIFT
			 tecla_pulsada=0x25;
			 }
        
             if(chatboardSymb){  PituKey(0x25);//SPECKEY_SYMB
			 tecla_pulsada=0x25;
			 }
        }
    }else{
        PituKey(0x25);
		tecla_pulsada=0x25;
    }*/
	
    get=gp_getChatboard();
    switch(get){
	 
     case '<':  //SHIFT -> 0x25
					 if(!chatboardShift){ //PULSAR
						 keyboard_matrix[ 0x25 >>4] &= ~bit_values[0x25&7]; 
						 chatboardShift=1;
					 }else{ //SOLTAR
						 keyboard_matrix[ 0x25 >>4] |= bit_values[0x25&7]; 
						 chatboardShift=0;
					 }
	 
					 break;
     case '>':  //INTRO -> 0x22
					 tecla_pulsada = 0x22;
					 keyboard_matrix[ tecla_pulsada >>4] &= ~bit_values[tecla_pulsada&7]; 
					 ticks=0;

                break;
	 case '\r': 
					 //BORRAR -> 0x97
					 tecla_pulsada = 0x97;
					 keyboard_matrix[ tecla_pulsada >>4] &= ~bit_values[tecla_pulsada&7]; 
					 ticks=0;
					 break;
	 
	 case 0: //soltamos
			 if(tecla_pulsada/*&&!spool*/){
				 ticks++;
				 if(ticks>10){
					 //gm_sprintf(spool_cad,"CHAT Soltada!");spool=1;
					 keyboard_matrix[ tecla_pulsada >>4] |= bit_values[tecla_pulsada&7];
					 tecla_pulsada=0;
					 //keypressed=0;
				 }
			 }
			 break;
	 
     default:
			 tecla_pulsada = keyboard_translation[(unsigned char) get];
			 if ((tecla_pulsada != 0xff)){
				 keyboard_matrix[ tecla_pulsada >>4] &= ~bit_values[tecla_pulsada&7]; 
				 ticks=0;
			 }
			 break;

    }

}



