/* PituKa - Amstrad CPC Emulator
   (c) Copyright 2004-2005 David Skywalker

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "../cap32.h"
#include "GPprintf.h"

//ANTIGUO STRINGS

int abs(int n)
{
	if(n<0)
		n=n*(-1);
	return n;
}
int isdigit(char c)
{
	return (c >= '0' && c <= '9');
} 

char *strcpy(char *dst, const char *src)
{
	register char *d = dst;
	while(*src)
		*dst++ = *src++;
	*dst++ = 0;
	return d;
} 

char *itoa_size(int v, char *dst, unsigned int base, int size, char fill_char)
{
	unsigned int uv;
	static const char digits[] = "0123456789ABCDEF";
	char tmp[34];
	char *p = &tmp[33];
	uchar neg = 0;

	if(!v) {
		*dst = '0';
		dst[1] = 0;
		return dst;
	}

	*p-- = 0;
	if(v < 0 && base == 10) {
		uv = -v;
		neg = 1;
	} else
		uv = v;

	while(uv >= base) {
		*p-- = digits[uv % base];
		size--;
		uv /= base;
	}
	*p = digits[uv];
	size--;
	while(size > 0) {
		*(--p) = fill_char;
		size--;
	}

	if(neg)
		*(--p) = '-';
	strcpy(dst, p);

	return dst;
}

char *itoa(int v, char *dst, unsigned int base)
{
	return itoa_size(v, dst, base, 0, ' ');
}
 



int GP_fprintf(F_HANDLE fp, char *fmt, ...)
{
	char tmp[256];
	int rc;
	va_list vl;
	va_start(vl, fmt);

	rc = GP_vsprintf(tmp, fmt, vl);
	//write((int)fp, tmp, strlen(tmp));
	GpFileWrite ((F_HANDLE)fp, tmp, gm_lstrlen(tmp));


	va_end(vl);
	return rc;
}
 

//int gm_memcmp(void * pt1, void * pt2, int size){
int gm_memcmp(const char * pt1, const  char * pt2, int size){

  int n;
  for(n=0;((pt1[n]==pt2[n])&&(n<size));n++);
  if(n==size)
     return 0;
  else
     return 1;

}


int GP_vsprintf(char *dest, char *fmt, va_list vl)
{
	int width = 0;
	int prec = 0;
	char *org = dest;
	while(*fmt) {
		switch(*fmt) {
		case '%':

			fmt++;
			if(*fmt == '%')
			{
				*dest++ = *fmt;
			}
			else
			{
				if(isdigit(*fmt) || *fmt == '.') {
					width = atoi(fmt);
					while(isdigit(*fmt))
						fmt++;
					if(*fmt == '.')
						prec = atoi(++fmt);
					while(isdigit(*fmt))
						fmt++;
				}
				if(*fmt == 'l' || *fmt == 'h')
					fmt++;
				if(!width)
					width = prec;

				switch(*fmt) {
				case 'd':
				case 'i':
				case 'u':
					itoa_size(va_arg(vl, int), dest, 10, width, '0');
					break;
				case 'p':
				case 'X':
				case 'x':
					itoa_size(va_arg(vl, int), dest, 16, width, '0');
					break;
				case 'c':
					*dest++ = (char)va_arg(vl, int);
					*dest = 0;
					break;
				case 's':
					strcpy(dest, va_arg(vl, char*));
					break;
				default:
					fmt++;
					break;
				}
				dest += gm_lstrlen(dest);
				break;
			}
			break;
		default:
			*dest++ = *fmt;
		}
		fmt++;
	}
	*dest = 0;
	return org-dest;
} 
