/* PituKa - Amstrad CPC Emulator
   (c) Copyright 2004-2005 David Skywalker

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "../cap32.h"

//GFX
#include "../gfx/logo.h"
#include "../gfx/teclado.h"
#include "../gfx/menu.h"

//caprice
#include "../font.c"


//dice si se pinta o no :-
bool pinta_menu;
GP_cursor seleccion={0,5,0,155};
//GP_cursor seleccion={0,1,0,115};

GP_cursor cfg_tecla={0,0,270,32};

cpc_byte reiniciado=0;

unsigned char submenu=0;

bool GPChangeDISK;
extern unsigned char num_snap;
extern const unsigned char botones_usr_DEFECTO[10];
extern unsigned char *botones_usr;
PituKa_CFG configuracion; 

Pituka_SpoolKeys spoolkeys={ {'\0'}, NULL, 0, FALSE };

char extension[5];
char file_state[13];
char rom_name[16]={'\0'};

bool save_state=0;
bool load_state=0;
unsigned char result_state=0; //1 load ok, //2 save ok


extern 	void * buffer;


GP_cursor puntero;

int GPframeskip=0;
int GPframe=0;
char spool_cad[20]={'\0'};
bool spool=0;
bool spool_act=0;

//CHATBOARD
int chatboard=0;
//int chatboardSymb=0, chatboardShift=0, chatboardExt=0;


//GPDRAWSURFACE * video_surface;
//GPDRAWSURFACE * back_surface;

//unsigned char * fondo;

//int nflip;			        /* Video buffer index */
//GPDRAWSURFACE gpDraw;	/* Video Buffers */
GP_HPALETTE paleta;         /* Paleta de Color 8bits */

extern const unsigned char logoPITUKAcont[76800];
extern const unsigned char logoPITUKAchat[76800];

extern const unsigned char tecladoPITUKA[20480];
extern GP_PALETTEENTRY logo_Pal[65];
extern GP_PALETTEENTRY teclado_Pal[16];

extern unsigned char *Picture;
extern unsigned char *PictureAlt;
extern int gpDrawSurfaceIndex;

extern t_CPC CPC;
extern bool sonido_ant;

extern cpc_byte keyboard_matrix[16];
extern cpc_byte keyboard_translation[320];
extern cpc_byte bit_values[8];



void print (cpc_byte *pdwAddr, char *pchStr, bool bolColour)
{
   int iLen, iIdx, iRow, iCol, n;
//   cpc_dword dwColour;
//   cpc_word wColour;
   cpc_byte bRow, bColour;

   switch (CPC.scr_bpp)
   {
      case 8:
         bColour = bolColour ? 0xFE : 0;
         iLen = gm_lstrlen(pchStr); // number of characters to process
         for ( n = 0; n < iLen; n++) {
            cpc_byte *pdwLine;
            cpc_byte *pbPixel;
            iIdx = (int)pchStr[n]; // get the ASCII value
            if ((iIdx < FNT_MIN_CHAR) || (iIdx > FNT_MAX_CHAR)) { // limit it to the range of chars in the font
               iIdx = FNT_BAD_CHAR;
            }
            iIdx -= FNT_MIN_CHAR; // zero base the index
            pdwLine = pdwAddr; // keep a reference to the current screen position
            for (iRow = 0; iRow < FNT_CHAR_HEIGHT; iRow++) { // loop for all rows in the font character
               pbPixel = (cpc_byte *)pdwLine;
               bRow = bFont[iIdx]; // get the bitmap information for one row
               for (iCol = 0; iCol < FNT_CHAR_WIDTH; iCol++) { // loop for all columns in the font character
                  if (bRow & 0x80) { // is the bit set?
                     //*(pbPixel+CPC_VISIBLE_SCR_HEIGHT) = 0xF0; // draw the "shadow"
                     //*(cpc_byte *)((cpc_dword *)pbPixel+CPC.scr_line_offs) = 0;
                     *((cpc_byte *)((cpc_dword *)pbPixel+CPC.scr_line_offs)+1) = 0xF0; //COLOR
                     *pbPixel = bColour; // draw the character pixel (SOMBRA)
                  }
                  pbPixel+=(CPC_VISIBLE_SCR_HEIGHT); // update the screen position
                  bRow <<= 1; // advance to the next bit
               }
               pdwLine --;//+= CPC.scr_line_offs; // advance to next screen line
               iIdx += FNT_CHARS; // advance to next row in font data
            }
            pdwAddr +=( CPC_VISIBLE_SCR_HEIGHT*(FNT_CHAR_WIDTH)); // set screen address to next character position
         }
         break;
   }
}


void pinta_led(unsigned char * LCD ){


	//pinta cursor
	LCD+=(230+300*240);
	cpc_byte color=0xF3;
	//int py=puntero.py+puntero.px*240;
	//de abajo a arriba
	
	
							*(LCD-1) =color;*(LCD++) =color;*(LCD++) =color;*(LCD) =color;
	LCD+=240-3;*(LCD++) =color;*(LCD++) =color;*(LCD++) =color;*(LCD) =color;
	LCD+=240-3;*(LCD++) =color;*(LCD++) =color;*(LCD++) =color;*(LCD) =color;
	LCD+=240-3;*(LCD++) =color;*(LCD++) =color;*(LCD++) =color;*(LCD) =color;
	LCD+=240-3;*(LCD++) =color;*(LCD++) =color;*(LCD++) =color;*(LCD) =color;
	LCD+=240-3;*(LCD++) =color;*(LCD++) =color;*(LCD++) =color;*(LCD) =color;
	LCD+=240-3;*(LCD++) =color;*(LCD++) =color;*(LCD++) =color;*(LCD) =color;
	LCD+=240-3;*(LCD++) =color;*(LCD++) =color;*(LCD++) =color;*(LCD) =color;
	


}

void pinta_teclado(unsigned char * LCD ){

//unsigned char * LCD = (unsigned char *)PictureAlt;
unsigned char * TEMP = NULL;
unsigned char * TEC = (unsigned char *) tecladoPITUKA;
int x,y;

TEMP=LCD;

//pone el teclado :D

for(y=0;y<320;y++){
	for(x=0;x<64;x++,TEMP++,TEC++)
		*TEMP=*TEC;
	TEMP+=CPC_VISIBLE_SCR_HEIGHT-64;
}
	
	//pinta cursor
	TEMP=LCD+(puntero.py+puntero.px*240);
	//int py=puntero.py+puntero.px*240;
	//de abajo a arriba
	
	*(TEMP-3) =0xF3;*(TEMP-2) =0xF3;*(TEMP-1) =0xF3;*(TEMP) =0xF3;
	TEMP+=240-2;*(TEMP++) =0xF3;*(TEMP++) =0xF3;*(TEMP) =0xF3;
	TEMP+=240-1;*(TEMP++) =0xF3;*(TEMP) =0xF3;
	*(TEMP+240)=0xF3;
	
	//unsigned char tecla_conf=UP_PRESSED;
	
if(cfg_tecla.x>	 LEFT_PRESSED){
	switch(cfg_tecla.x){
	
		case A_PRESSED:
					cfg_tecla.px=236;
					cfg_tecla.py=42;
				break;
		case B_PRESSED:
					cfg_tecla.px=230;
					cfg_tecla.py=36;
				break;
		case SELECT_PRESSED:
					cfg_tecla.px=230;
					cfg_tecla.py=24;

	}
	
	 	TEMP=LCD+(cfg_tecla.py+cfg_tecla.px*240);
	//pinta indicador en la zona dada
	//de abajo a arriba
	
	*(TEMP-2) =0xF3;*(TEMP-1) =0xF3;*(TEMP) =0xF3;
	//TEMP+=240-2;*(TEMP++) =0xF3;*(TEMP++) =0xF3;*(TEMP) =0xF3;
	TEMP+=240-1;*(TEMP++) =0xF3;*(TEMP) =0xF3;
	*(TEMP+240)=0xF3;

	}else{
	
		switch(cfg_tecla.x){
				 case UP_PRESSED:
					cfg_tecla.px=210;
					cfg_tecla.py=41;
					TEMP=LCD+(cfg_tecla.py+cfg_tecla.px*240);
					*(TEMP) =0xF3;*(TEMP++) =0xF3;*(TEMP++) =0xF3;
					*(TEMP-240) =0xF3;
					*(TEMP+240) =0xF3;
					*(TEMP++) =0xF3;*(TEMP++) =0xF3;
					break;
				 case RIGHT_PRESSED:
					cfg_tecla.px=211;
					cfg_tecla.py=40;
					TEMP=LCD+(cfg_tecla.py+cfg_tecla.px*240);
					*(TEMP) =0xF3;*(TEMP+=240)=0xF3;*(TEMP+=240)=0xF3;
					*(TEMP+1) =0xF3;
					*(TEMP-1) =0xF3;
					*(TEMP+=240)=0xF3;
					break;
				 case DOWN_PRESSED:
					cfg_tecla.px=210;
					cfg_tecla.py=36;
					TEMP=LCD+(cfg_tecla.py+cfg_tecla.px*240);
					*(TEMP++) =0xF3;
					*(TEMP-240) =0xF3;
					*(TEMP+240) =0xF3;
					*(TEMP++) =0xF3;*(TEMP++) =0xF3;*(TEMP++) =0xF3;
//					*(TEMP) =0xF3;
					break;
				 case LEFT_PRESSED:
					cfg_tecla.px=206;
					cfg_tecla.py=40;
					TEMP=LCD+(cfg_tecla.py+cfg_tecla.px*240);
					*(TEMP) =0xF3;
					*(TEMP+=240) =0xF3;
					*(TEMP+1) =0xF3;
					*(TEMP-1) =0xF3;
					*(TEMP+=240)=0xF3;*(TEMP+=240)=0xF3;
					break;
		}

	
	}
}



void menu (void){

int n;//,m;
char chStr[40];

		 volatile long *lcdcon1 = (long *)0x14a00000;
		 unsigned char * LCD = (unsigned char *)0x0c7b4000;
		 
		 


//pone el menu :D
for(n=0;n<76800;n++,LCD++)*LCD=menu_p[n];

//reset posicion
//LCD = (unsigned char *)0x0c7b4000;

while(1!=(((*lcdcon1)>>18)&0x1ff));

if(!submenu){
print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*120)+180), (char*)".: MENU :.", false); // LETRITAS :D

if(rom_name=='\0' || rom_name[0]=='.')
	gm_sprintf(chStr,"Insert Disk [ none ]");
else
	gm_sprintf(chStr,"Insert Disk [%s] ",rom_name);
	//gm_sprintf(chStr,"X: '%s' %i Insert Disk [%s] ",extension,(int)GPChangeDISK,rom_name);
	//gm_sprintf(chStr,"Insert Disk [%s] ",rom_name);
	//gm_sprintf(chStr,"X: '%s' Insert Disk [%s] ",extension,rom_name);


print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*70)+155), (char*)chStr, true); // LETRITAS :D
print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*70)+140), (char*)"Snapshots", true); // LETRITAS :D
print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*70)+125), (char*)"Options", true); // LETRITAS :D
print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*70)+110), (char*)"Restart CPC", true); // LETRITAS :D
print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*70)+95), (char*)"Exit PituKa", true); // LETRITAS :D
print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*80)+65), (char*)"( START TO RETURN )", false); // LETRITAS :D

print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*60)+seleccion.py), (char*)">", false); // LETRITAS :D

 //CHATBOARD
   if(chatboard)
     {
		  gm_sprintf(chStr,"Chatboard found! to use press SMS Key"); //(%c)", gp_getChatboard());
		  print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*10)+10), (char*)chStr, true);
     }
	 /*else{
		 //DEBUG
		  gm_sprintf(chStr,"%s", (char*) GPDebug); //(%c)", gp_getChatboard());
		  print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*10)+10), (char*)chStr, true);
	 }*/

  
  
}else 
if(submenu==1){

print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*80)+180), (char*)".: MENU - OPTIONS :.", false); // LETRITAS :D
/*
   CPC.scr_tube = 0; //0 COLOR / 1 VERDE
   CPC.scr_intensity = 10;
   CPC.snd_enabled = 1; //getConfigValueInt(chFileName, "sound", "enabled", 1) & 1;
*/
print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*70)+155), (char*)"Tube (G/C): ", true); // LETRITAS :D
	if(!CPC.scr_tube)
		print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*180)+155), (char*)"COLOR", true); // LETRITAS :D
	else
		print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*180)+155), (char*)"GREEN", true); // LETRITAS :D

print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*70)+135), (char*)"Sound (Y/N): ", true); // LETRITAS :D
	if(!sonido_ant)
		print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*180)+135), (char*)"NO", true); // LETRITAS :D
	else
		print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*180)+135), (char*)"YES", true); // LETRITAS :D
print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*70)+115), (char*)"Gamma: ", true); // LETRITAS :D
	gm_sprintf(chStr,"%i",(int)(CPC.scr_intensity-10));
	print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*180)+115), (char*)chStr, true); // LETRITAS :D
	
print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*70)+95), (char*)"Back to main menu", true); // LETRITAS :D

print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*60)+seleccion.py), (char*)">", false); // LETRITAS :D
}else
if(submenu==2){

print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*80)+180), (char*)".: MENU - SNAPSHOT :.", false); // LETRITAS :D

print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*70)+135), (char*)"Load SNAPSHOT", true); // LETRITAS :D
print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*70)+115), (char*)"Save SNAPSHOT ", true); // LETRITAS :D

if(result_state)
	print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*180)+95+(20*result_state)), (char*)"[ OK ]", true); // LETRITAS :D

print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*70)+95), (char*)"Back to main menu", true); // LETRITAS :D


print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*60)+seleccion.py), (char*)">", false); // LETRITAS :D

	gm_sprintf(chStr,"   ( %s ) ",file_state);

print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*80)+65), (char*)chStr, false); // LETRITAS :D

}

//while(GpKeyGet()!=0x200);//GPC_VK_SELECT

			//	gm_sprintf(chStr,"Py: %i Y: %i", (int)seleccion.py, (int)seleccion.y); //para hacer el spool de comandos...
		     //	print((cpc_byte *)Picture+((GPC_LCD_HEIGHT*3)+10), (char*)chStr, true); // SPOOL


//resetear paleta si esta funcionando a la del cpc... sino... xD
pinta_menu = 0;

}


void save_cfgkey(char * filename){
	char path[50];
	char temp[15]={'\0'};
	F_HANDLE fp;

	if(filename[0]!='\0'/* && (gm_memcmp(filename, "none", 4)!=0) */){
		gm_strncpy(temp, (char*)&filename[0], (gm_lstrlen(filename)-4)); // grab the extension
		gm_sprintf(path,"gp:\\gpmm\\amstrad\\snaps\\cfg\\%s.ini",(char*)temp);
		if(GpFileCreate(path,ALWAYS_CREATE,&fp)==SM_OK){
			GpFileClose(fp);
			if(GpFileOpen(path,OPEN_W,&fp)==SM_OK)
			{
			 GpFileWrite(fp,&configuracion.botones_usr[0],10); 
			 GpFileClose(fp);
			}
		}
	}

}

/*
typedef struct{
bool sonido_ant;
unsigned int scr_tube;
unsigned int scr_intensity;
unsigned char botones_usr[10];
unsigned char num_snap;
char rom_name[16];
}PituKa_CFG;

*/

void process_savecfg (void){
	
//sonido_ant
//CPC.scr_tube
//CPC.scr_intensity
//botones_usr
//num_snap
//rom_name

	gm_strcpy(configuracion.rom_name,rom_name);
	configuracion.num_snap=num_snap;
	configuracion.sonido_ant=sonido_ant;
	configuracion.scr_tube=CPC.scr_tube;
	
	//gm_strncpy(configuracion.botones_usr,botones_usr, 9);
	configuracion.scr_intensity=CPC.scr_intensity;
	
	char path[50];
	gm_sprintf(path,"gp:\\gpmm\\amstrad\\amstrad.ini");


F_HANDLE fp;

	  if(GpFileCreate(path,ALWAYS_CREATE,&fp)==SM_OK)
       {
        GpFileClose(fp);

			if(GpFileOpen(path,OPEN_W,&fp)==SM_OK)
			{
			 GpFileWrite(fp,&configuracion,sizeof(PituKa_CFG)); 
			 GpFileClose(fp);
			}
		}
		//grabamos las teclas para el disco
		save_cfgkey(configuracion.rom_name);
		
		//snapshot_save (path); //lo del path es temporal... xD
		//pregunta_grabar();
		/*
		if(save_state){
			gm_sprintf(path,"STATE000.PTK");
			snapshot_save (path); //lo del path es temporal... xD
		}
		*/
		GpFATUpdate("GP://");
		
		
}

void load_cfgkey(char * filename){
	char path[50];
	char temp[15]={'\0'};
	F_HANDLE fp;
	ulong leido=0;

	if(filename[0]!='\0'){
		gm_strncpy(temp, (char*)&filename[0], (gm_lstrlen(filename)-4)); // grab the extension
		gm_sprintf(path,"gp:\\gpmm\\amstrad\\snaps\\cfg\\%s.ini",(char*)temp);
		if(GpFileOpen(path, OPEN_R, &fp)==SM_OK) {
			GpFileRead((F_HANDLE)fp, &configuracion.botones_usr[0], 10, (ulong*)&leido);
			GpFileClose(fp);
//			botones_usr=&configuracion.botones_usr[0];
		}
	}else{
		//botones por defecto
		for(leido=0;leido<9;leido++)
			configuracion.botones_usr[leido] = botones_usr_DEFECTO[leido];
	}
}

void process_loadcfg (void){
	F_HANDLE fp;
	GPFILEATTR file_attrib;
	ulong leido=0;
	char path[50];
	gm_sprintf(path,"gp:\\gpmm\\amstrad\\amstrad.ini");

	 if (GpFileOpen(path, OPEN_R, &fp)==SM_OK) {
		GpFileRead((F_HANDLE)fp, &configuracion, sizeof(PituKa_CFG), (ulong*)&leido);
		GpFileClose(fp);
		
		//botones_usr=&configuracion.botones_usr[0];
		
		GPChangeDISK=1;
	 }else{
		configuracion.sonido_ant=1;
		configuracion.scr_tube = 0;
		configuracion.scr_intensity = 10;

		configuracion.num_snap=0;
		gm_strncpy(configuracion.rom_name,"\0", 1);
		
		GPChangeDISK=0;
	}
	
	leido=0;
	//cargamos la cfg del teclado
	load_cfgkey(configuracion.rom_name);
	
	//Creacion de directorios
	if(GpFileAttr ("gp:\\gpmm\\amstrad", &file_attrib)==ERR_NOT_FOUND){
		GpDirCreate ("gp:\\gpmm\\amstrad", leido);
		GpFATUpdate("GP://");
	}

	if(GpFileAttr ("gp:\\gpmm\\amstrad\\disks", &file_attrib)==ERR_NOT_FOUND){
		GpDirCreate ("gp:\\gpmm\\amstrad\\disks", leido);
		GpFATUpdate("GP://");
	}
	
	if(GpFileAttr ("gp:\\gpmm\\amstrad\\snaps", &file_attrib)==ERR_NOT_FOUND){
		GpDirCreate ("gp:\\gpmm\\amstrad\\snaps", leido);
		GpFATUpdate("GP://");
	}
	
	if(GpFileAttr ("gp:\\gpmm\\amstrad\\snaps\\cfg", &file_attrib)==ERR_NOT_FOUND){
		GpDirCreate ("gp:\\gpmm\\amstrad\\snaps\\cfg", leido);
		GpFATUpdate("GP://");
	}
	
	if(GpFileAttr ("gp:\\gpmm\\amstrad\\screens", &file_attrib)==ERR_NOT_FOUND){
		GpDirCreate ("gp:\\gpmm\\amstrad\\screens", leido);
		GpFATUpdate("GP://");
	}
	
	

	
	//Variables iniciales
	gm_strcpy(rom_name, configuracion.rom_name);
	pinta_menu = 1;
	num_snap=configuracion.num_snap;
	botones_usr=&configuracion.botones_usr[0];
	sonido_ant=configuracion.sonido_ant;

}



void process_spoolkey(int spool_ticks){
static cpc_byte tecla_pulsada='\0';
//static cpc_byte tecla_pulsada_ultima='\0';
static int tiempo_spool=0;
static bool pulsada=FALSE;

					 if(spoolkeys.comienzo==TRUE){
						 spoolkeys.cur=&spoolkeys.contenido[0];
						 spoolkeys.cont=gm_lstrlen(spoolkeys.contenido);
						 //le aadimos el intro
						 spoolkeys.cont++;
						 //no mas iniciaciones
						 spoolkeys.comienzo=FALSE;
						 tecla_pulsada='\0';
					}
				
				if((tiempo_spool+spool_ticks)>50){ //si han pasado 50ms
					tiempo_spool-=50; //asi siempre empezamos de 0 :)
					
					tecla_pulsada=keyboard_translation[*spoolkeys.cur];
					
					if ((tecla_pulsada != 0xff)){
						 if(pulsada==FALSE){
							 keyboard_matrix[tecla_pulsada >> 4] &= ~bit_values[tecla_pulsada & 7]; // tecla pulsada
							 pulsada=TRUE;
						 }else{
						     keyboard_matrix[tecla_pulsada >> 4] |= bit_values[tecla_pulsada & 7];  // tecla soltada
							 pulsada=FALSE;
						 }
					 }else{
					   if(*spoolkeys.cur=='|'){
						   if(gm_compare(spoolkeys.contenido,"|cpm")==0){ //son iguales :?
							 if(pulsada==FALSE){
								 keyboard_matrix[ 0x32 >> 4] &= ~bit_values[ 0x32 & 7]; // tecla pulsada -> "|"
								 keyboard_matrix[ 0x25 >> 4] &= ~bit_values[ 0x25 & 7]; // tecla pulsada -> 0x25 (SHIFT)
								 pulsada=TRUE;
							 }else{
								 keyboard_matrix[ 0x32 >> 4] |= bit_values[ 0x32 & 7];  // tecla soltada -> "|"
								 keyboard_matrix[ 0x25 >> 4] |= bit_values[ 0x25 & 7];  // tecla soltada -> 0x25 (SHIFT)
								 pulsada=FALSE;
							 }
						  }else{
							 if(pulsada==FALSE){
								 keyboard_matrix[ 0x81 >> 4] &= ~bit_values[ 0x81 & 7]; // tecla pulsada -> "
								 keyboard_matrix[ 0x25 >> 4] &= ~bit_values[ 0x25 & 7]; // tecla pulsada -> 0x25 (SHIFT)
								 pulsada=TRUE;
							 }else{
								 keyboard_matrix[ 0x81 >> 4] |= bit_values[ 0x81 & 7];  // tecla soltada -> "
								 keyboard_matrix[ 0x25 >> 4] |= bit_values[ 0x25 & 7];  // tecla soltada -> 0x25 (SHIFT)
								 pulsada=FALSE;
							 }
						  
						  }
					   }else if(*spoolkeys.cur=='\0'){
							 if(pulsada==FALSE){
								 keyboard_matrix[ 0x06 >> 4] &= ~bit_values[ 0x06 & 7]; // tecla pulsada -> INTRO
								 pulsada=TRUE;
							 }else{
								 keyboard_matrix[ 0x06 >> 4] |= bit_values[ 0x06 & 7];  // tecla soltada -> INTRO
								 pulsada=FALSE;
							 }
					   }else if(*spoolkeys.cur=='!'){
							 if(pulsada==FALSE){
								 keyboard_matrix[ 0x80 >> 4] &= ~bit_values[ 0x80 & 7]; // tecla pulsada -> "1"
								 keyboard_matrix[ 0x25 >> 4] &= ~bit_values[ 0x25 & 7]; // tecla pulsada -> 0x25 (SHIFT)
								 pulsada=TRUE;
							 }else{
								 keyboard_matrix[ 0x80 >> 4] |= bit_values[ 0x80 & 7];  // tecla soltada -> "1"
								 keyboard_matrix[ 0x25 >> 4] |= bit_values[ 0x25 & 7];  // tecla soltada -> 0x25 (SHIFT)
								 pulsada=FALSE;
							 }
					   }else if(*spoolkeys.cur=='#'){
							 if(pulsada==FALSE){
								 keyboard_matrix[ 0x71 >> 4] &= ~bit_values[ 0x71 & 7]; // tecla pulsada -> "3"
								 keyboard_matrix[ 0x25 >> 4] &= ~bit_values[ 0x25 & 7]; // tecla pulsada -> 0x25 (SHIFT)
								 pulsada=TRUE;
							 }else{
								 keyboard_matrix[ 0x71 >> 4] |= bit_values[ 0x71 & 7];  // tecla soltada -> "3"
								 keyboard_matrix[ 0x25 >> 4] |= bit_values[ 0x25 & 7];  // tecla soltada -> 0x25 (SHIFT)
								 pulsada=FALSE;
							 }
					   }else if(*spoolkeys.cur=='+'){
							 if(pulsada==FALSE){
								 keyboard_matrix[ 0x34 >> 4] &= ~bit_values[ 0x34 & 7]; // tecla pulsada -> "; o "
								 keyboard_matrix[ 0x25 >> 4] &= ~bit_values[ 0x25 & 7]; // tecla pulsada -> 0x25 (SHIFT)
								 pulsada=TRUE;
							 }else{
								 keyboard_matrix[ 0x34 >> 4] |= bit_values[ 0x34 & 7];  // tecla soltada -> "; o "
								 keyboard_matrix[ 0x25 >> 4] |= bit_values[ 0x25 & 7];  // tecla soltada -> 0x25 (SHIFT)
								 pulsada=FALSE;
							 }
					   }else if(*spoolkeys.cur=='{'){
							 if(pulsada==FALSE){
								 keyboard_matrix[ 0x21 >> 4] &= ~bit_values[ 0x21 & 7]; // tecla pulsada -> "{ o ["
								 keyboard_matrix[ 0x25 >> 4] &= ~bit_values[ 0x25 & 7]; // tecla pulsada -> 0x25 (SHIFT)
								 pulsada=TRUE;
							 }else{
								 keyboard_matrix[ 0x21 >> 4] |= bit_values[ 0x21 & 7];  // tecla soltada -> "{ o ["
								 keyboard_matrix[ 0x25 >> 4] |= bit_values[ 0x25 & 7];  // tecla soltada -> 0x25 (SHIFT)
								 pulsada=FALSE;
							 }
					   }else if(*spoolkeys.cur=='}'){
							 if(pulsada==FALSE){
								 keyboard_matrix[ 0x23 >> 4] &= ~bit_values[ 0x23 & 7]; // tecla pulsada -> "} o ]"
								 keyboard_matrix[ 0x25 >> 4] &= ~bit_values[ 0x25 & 7]; // tecla pulsada -> 0x25 (SHIFT)
								 pulsada=TRUE;
							 }else{
								 keyboard_matrix[ 0x23 >> 4] |= bit_values[ 0x23 & 7];  // tecla soltada -> "} o ]"
								 keyboard_matrix[ 0x25 >> 4] |= bit_values[ 0x25 & 7];  // tecla soltada -> 0x25 (SHIFT)
								 pulsada=FALSE;
							 }
					   }else if(*spoolkeys.cur=='&'){
							 if(pulsada==FALSE){
								 keyboard_matrix[ 0x60 >> 4] &= ~bit_values[ 0x60 & 7]; // tecla pulsada -> "6"
								 keyboard_matrix[ 0x25 >> 4] &= ~bit_values[ 0x25 & 7]; // tecla pulsada -> 0x25 (SHIFT)
								 pulsada=TRUE;
							 }else{
								 keyboard_matrix[ 0x60 >> 4] |= bit_values[ 0x60 & 7];  // tecla soltada -> "6"
								 keyboard_matrix[ 0x25 >> 4] |= bit_values[ 0x25 & 7];  // tecla soltada -> 0x25 (SHIFT)
								 pulsada=FALSE;
							 }
					   }else if(*spoolkeys.cur=='\''){
							 if(pulsada==FALSE){
								 keyboard_matrix[ 0x51 >> 4] &= ~bit_values[ 0x51 & 7]; // tecla pulsada -> "7"
								 keyboard_matrix[ 0x25 >> 4] &= ~bit_values[ 0x25 & 7]; // tecla pulsada -> 0x25 (SHIFT)
								 pulsada=TRUE;
							 }else{
								 keyboard_matrix[ 0x51 >> 4] |= bit_values[ 0x51 & 7];  // tecla soltada -> "7"
								 keyboard_matrix[ 0x25 >> 4] |= bit_values[ 0x25 & 7];  // tecla soltada -> 0x25 (SHIFT)
								 pulsada=FALSE;
							 }
					   }else if(*spoolkeys.cur=='^'){ //pone libra
							 if(pulsada==FALSE){
								 keyboard_matrix[ 0x30 >> 4] &= ~bit_values[ 0x30 & 7]; // tecla pulsada -> "^"
								 keyboard_matrix[ 0x25 >> 4] &= ~bit_values[ 0x25 & 7]; // tecla pulsada -> 0x25 (SHIFT)
								 pulsada=TRUE;
							 }else{
								 keyboard_matrix[ 0x30 >> 4] |= bit_values[ 0x30 & 7];  // tecla soltada -> "^"
								 keyboard_matrix[ 0x25 >> 4] |= bit_values[ 0x25 & 7];  // tecla soltada -> 0x25 (SHIFT)
								 pulsada=FALSE;
							 }
					   }// falta @
					 }
					
					if(pulsada==FALSE){
						 if(spoolkeys.cont>1){
						     if(*spoolkeys.cur!=*(spoolkeys.cur+1)){
								 spoolkeys.cur++;
								 spoolkeys.cont--;
							 }else{
								 *spoolkeys.cur=0x01;
							 }
							 
							 
						 }else{
							 spoolkeys.cur=&spoolkeys.contenido[0];
							 spoolkeys.cont=0;
							 spoolkeys.contenido[0]='\0';
							 tiempo_spool=0;
						 }
					}
					
				}


}



void logo(int img){


unsigned char * LCD = (unsigned char *)0x0c7b4000;
int n;

    GpGraphicModeSet(GPC_DFLAG_8BPP, NULL);
	    paleta = GpPaletteCreate (65,(GP_PALETTEENTRY *) logo_Pal);
        GpPaletteSelect (paleta);
        GpPaletteRealize();

if(!img){
		

//pone el logo :D
		for(n=0;n<76800;n++,LCD++)*LCD=logoPITUKAcont[n];
}else{

//buscando chatboard :d
		for(n=0;n<76800;n++,LCD++)*LCD=logoPITUKAchat[n];

}

}
