/* pituka.h - PituKa Base
 *
 * Copyright (c) 2005 David Skywalker <dantoine@gmail.com>
 *
 * Only for education and learn
 * 
 *
 */ 

 #ifndef PITUKA_H
#define PITUKA_H

#include "GPprintf.h"
#include "GPio.h"

typedef struct{
cpc_byte contenido[25];
cpc_byte * cur;
unsigned char cont;
bool comienzo;
}Pituka_SpoolKeys;

typedef struct{
char archivo[15];
char ejecutable[15];
}Pituka_files;

typedef struct{
bool sonido_ant;
unsigned int scr_tube;
unsigned int scr_intensity;
unsigned char botones_usr[10];
unsigned char num_snap;
char rom_name[16];
}PituKa_CFG;



typedef struct{
  int x, y;
  int w, h;
} GP_Rect;

typedef struct{
  int x, y;
  int px, py;
} GP_cursor;

//prints a string
void print (cpc_byte *pdwAddr, char *pchStr, bool bolColour);

//cap32.c
void pinta_led(unsigned char * LCD );
//display the vkey
void pinta_teclado(unsigned char * LCD );
//display menu
void menu (void);
//spool keys for autorun
void process_spoolkey(int spool_ticks);
//display init splash screen
void logo(int img);

//explorer.c
void process_savecfg (void);
void process_loadcfg (void);
//save cfgkey unique by game
void save_cfgkey(char * filename);
//load cfgkey unique by game
void load_cfgkey(char * filename);

#ifdef DEBUG_Z80
//Z80.c
//not used
void video_display (int vsync);
#endif

//CHATBOARD MIRKO
extern int gp_initChatboard(void);
extern unsigned char gp_getChatboard(void); 
extern void gp_setCpuspeed(int freq);
#endif
